// "js/OneSignal.js","js/analytics.js", "lib/google-analytics-bundle.js", "js/ChromePlatformAnalytics.js", "js/background.js"
//图标点击事件
chrome.action.onClicked.addListener(function (tab) {
  // Analytics.trackEvent(["unicorn", "run"]); //谷歌分析事件跟踪（第一个参数为跟踪对象，此处指Unicorn Smasher扩展，为必填项，第二个参数为对象状态，必填参数）
  // ChromePlatformAnalytics.sendEvent(["us", "searched"]); //谷歌分析事件跟踪（第一个参数为跟踪对象，为类别，必填项，名字随便定义，第二个参数为对象行为，必填参数）
  chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
    //获取当前活动窗口标签页，
    chrome.tabs.sendMessage(
      tabs[0].id,
      {
        //向当前标签页中的内容脚本发送带有uniMessage和data参数的消息,onpage.js页面接收信息，调用popup页面。插件需要tabs方法发送消息,从Google Chrome扩展程序页面发送请求消息给content scripts的时候，需要给出当前tab的ID
        uniMessage: "starts", //传送变量值，
        data: {
          analyticsPrompt: true,//!ChromePlatformAnalytics.getUserPrompted(),
        },
      },
      function (response) {
        //处理接收方发送的消息
      }
    );
  });
});

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
  //接收product.js发送的产品消息
  let params = null;
  if (request.type == "USK_LOAD_PRODUCT") {
    fetchPage(request.url).then(res => sendResponse({
      url: request.url,
      response: {
        status: 200,
        body: res,
      },
    }))
      .catch(err => {
        // console.log("-----------err",request.url)
        sendResponse(params)
      })
    return true; // keeps the channel open for sendResponse
  } else {
    return false
  }
});
const fetchPage = async (url) => {
  const getData = await fetch(url);
  const getText = await getData.text();
  return getText
};
// chrome.runtime.onInstalled.addListener(function (details) {
//   //当第一次安装、更新至新版本监听事件
//   if (details.reason === "install") {
//     //当第一次安装时
//     Analytics.trackEvent(["extension", "install"]); //谷歌分析
//     ChromePlatformAnalytics.sendEvent(["us", "installed"]); //谷歌平台分析
//   } else if (details.reason === "update") {
//   } //当更新至新版本时
// });

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
  //接收内容脚本传过来的数据，
  // console.log(
  //   sender.tab
  //     ? "from a content script:" + sender.tab.url
  //     : "from the extension"
  // );
  if (request.action == "saveSearch") {
    //对应search.js的storeResults方法
    if (request.search.domain != "" && request.search.keywords != "") {
      //
      //      var history = "_history" + request.search.domain + request.search.keywords;
      chrome.storage.local.set({
        ["_history " + request.search.domain + " " + request.search.keywords]:
          request.search,
      });
    }
  }

  if (request.action == "refreshSidebar") {
    //给内容脚本发送消息

    chrome.tabs.query({ title: "Unicorn Smasher Dashboard" }, function (tabs) {
      //

      for (i = 0; i < tabs.length; i++) {
        chrome.tabs.sendMessage(tabs[i].id, { action: "refreshSidebar" });
      }
    });
  }

  if (request.action == "removeSearch") {
    //
    chrome.storage.local.remove(
      "_history " + request.search.domain + " " + request.search.keywords,
      function () {
        sendResponse({ message: "complete" });
      }
    );
  }

  if (request.action == "toDashboard") {
    // ChromePlatformAnalytics.sendEvent(["us", "toDashboard"]);
    chrome.tabs.query({ title: "Unicorn Smasher Dashboard" }, function (tabs) {
      if (tabs.length > 0) {
        chrome.tabs.update(tabs[0].id, { selected: true }); //
        chrome.tabs.reload(tabs[0].id); //
      } else {
        //
        chrome.tabs.create({ url: chrome.runtime.getURL("/dashboard.html") }); //打开dashboard页面
      }
    });
    sendResponse()
  }
  return true;
});

// //谷歌消息推送
// OneSignal.init({
//   appId: "d3faf157-4aff-4274-8f14-8d8829648f87",
//   googleProjectNumber: "unicorn-smasher-pro",
// });

