// ca:
// com:
// de:
// es:
// fr:
// it:
// jp:
// uk:
const amazon = (function () {
  const amazonProfiles = {
    //每个站点对应的常量和正则
    /* BRAZIL 巴西 */
    br: {
      domain: "www.amazon.com.br",
      supported: false,
    },
    /* CANADA 加拿大 */
    ca: {
      domain: "www.amazon.ca",
      supported: true,
      sales: true,
      ssl: true,
      currency: "$",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },
          html: {
            bestsellers: /<ol id="zg-ordered-list"[\s\S]*?<\/ol>/,
            products2: /<li [\s\S]*?<\/li>/g,

            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /(".*?" data-index=[\s\S]*?data-asin=)/gi,
            // products2: /(role=[\s\S]*?class="zg-item-immersion")/gi,

            products3:
              /(<div id="gridItemRoot[\s\S]*?<span class="a-size-base a-color-price">)/gi,
            title3: /id="productTitle"[\s\S]*?<\/span>/gi,

            multiList: /(<li class="a-carousel-card[\s\S]*?<\/li>)/g,
            rank: /id="result_(.+?)"/gi,
            asin: /"(.*?)" data-index=/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            title1: /<img[\s\S]*?alt="(.*?)"/gi,
            titles: /<a[\s\S]*?<img alt="(.*?)"/i,
            link: /<a class="a-link-normal a-text-normal" href="(.*?)"/i,
            link1: /title=.*?href="(.*?)"/gi,
            link2: /<a class="a-link-normal[\s\S]*?href="(.*?)"/i,
            link3: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,

            brand: />by <\/span>.*?>(.*?)</gi,
            brandDetail: /id="bylineInfo.*?>(.*?)</gi,

            // price: /a-color-price.*?>.*?(\d*\.?\d+)/gi,
            price: /a-text-price.*?>.*?(\d*\.?\d+)/gi,
            //price2: /a-color-secondary.*?>.*?(\d*\.?\d+)/ig,
            price1: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,
            rating: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)/gi,
            reviews: /customerReviews.*?>([\d,]*)/gi,
            reviews1: /customerReviews.*?>([\d,]*)<\/span>/i,
            reviews2: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            reviews3: /acrCustomerReviewText.*?>([\d,]*) customer reviews/i,
            reviews4:
              /<a class="a-link-normal[\s\S]*?a-size-base">([\d,]*?)</gi,

            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName:
            /id="customer_review[\s\S]*?<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars:
            /id="customer_review[\s\S]*?<a class="a-link-normal" title="(.*?) /gi,
          date: /id="customer_review[\s\S]*?<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            salesRank: /Rank[\s\S]*?#([\d,]*) in .*?See Top 100/gi,
            salesRank1: /Best Sellers Rank[\s\S]*?#([\d.,]*) in .*? /i,
            salesRank2: / Best Sellers Rank[\s\S]*?<span>[\s\S]*?#[\s\S]*?([\d.,]*) in .*? /i,
            salesRank3: /Best Sellers Rank: <\/span>[\s\S]*?#[\s\S]*?([\d.,]*) in .*? /i,
            features: /id="feature-bullets[\s\S]*?>([\s\S]*?)<\/ul>/gi,

            features2: /<li>([\s\S]*?)<\/li>/gi,
            //salesRank: /id="SalesRank"[\s\S]*?#([\d.,]*) in/ig,
            //salesRank2: /Best Sellers Rank[\s\S]*?#([\d.,]*) in/i,
            category: /Rank[\s\S]*?#[\d.,]* in (.*?) \(/,
            category1:
              /Best Sellers Rank[\s\S]*?bestsellers[\s\S]*?>(.*?)<\/a>/gi,
            //category: /See Top 100 in (.*?)</i,
            //category2: /in&nbsp;.*?>(.*?)</i,
            //category3: /id="SalesRank"[\s\S]+?#(?:.+?) in (.*?) \(/i,
            //category4: /Best Sellers Rank[\s\S]*?#[\d.,]* in ([\s\S]*?) \(/i,
            //category5: /class='nav-a nav-b'><span class="nav-a-content">(.*?)</i,  //add
            merchantInfo: /id="merchant-info[\s\S]*?>([\s\S]*?)<\/div/i,
            title: /id="productTitle[\s\S]*?>([\s\S]*?)</i,
            fba2: /class="tabular-buybox-text"[\s\S]*?<span class="a-size-small">[\s\S]*?<\/div>/gi,

            fba: /(isAmazonFulfilled=1)/i,
            // fba3:/<span> and[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            sponsored: /(Sponsored)/gi,
            date: /Date first[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            date1: /Date first[\s\S]*?<span>([\s\S]*?)<\/span>/i,
            amz: /(sold by Amazon.ca)/i,
            fbm: /(sold by)/i,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            price: /id="priceblock_[\s\S]*?\$(.*?)(?:<| )/i,
            price2:
              /id="usedBuySection[\s\S]*?offer-price[\s\S]*?>CDN\$(.*?)<\/span>/gi,
            price1:
              /<span id="price_inside_buybox" class="a-size-medium a-color-price">([\s\S]*?)<\/span>/i,
            price3: /id="newBuyBoxPrice"[\s\S]*?>([\s\S]*?)<\/span>/,
            price4:
              /id="priceInsideBuyBox_feature_div"[\s\S]*?class="a-size-medium a-color-price priceString">([\s\S]*?)<\/span>/i,
            price5:
              /class="a-price a-text-price a-size-medium"[\s\S]*?aria-hidden="true">([\s\S]*?)<\/span>/gi,
            price6: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,

            //price1: /Price[\s\S]*?price_inside_buybox.*?CDN\$(.*?)</ig,
            //priceBody: /<divid="priceInsideBuyBox_feature_div[\s\S]*?(.*?)<\/div>/ig,
            //price3: /offer-price.*?>([\d\.]*)</i,
            reviews: /acrCustomerReviewText.*?>([\d,]*) ratings/i,
            reviews1: /<span id="acrCustomerReviewText" class="a-size-base">(.*?) rating<\/span>/gi,
            variationsJson:
              /displayTypeProperties[\s\S]*"dimensionValuesDisplayData" : ({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,
            weight:
              /(Pounds)|(Kilograms)|(kilogrammes)|(kilogramos)|(Grams)|(Kilogramm)|(Gramm)|(grammes)|(Ounces)|(Kg)|(grammi)|(gramos)/gi,
            is_adult:
              /(Erotic Massage Kits)|(Erotic Massagers & Vibrators)|(Bladder Control Devices)|(Appareils masturbateurs cup)|(Masseurs électriques portables)/,
            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
          },
          product_Details: {
            brandDetailUrl: /<a id="bylineInfo[\s\S]*?href="(.*?)">/i,
            brandDetail: /<a id="bylineInfo.*?>(.*?)<\/a>/i,
            BSR_TABLE2:
              /<table id="productDetails_techSpec_section_1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            soldBy: /<span class="tabular-buybox-text">([\s\S]*?)<\/span>/gi,
            coupon:
              /<td class="a-span12 a-color-price a-size-base">([\s\S]*?)<\/td>/,
            coupon3: /<span class="a-size-large a-color-price savingPriceOverride.*?>([\s\S]*?)<\/span>/gi,
            // seller:
            //   /<div class="a-box mbc-offer-row pa_mbc_on_amazon_offer">([\s\S]*?)<\/div>/,
            seller: /id=['"]sellerProfileTriggerId['"]>\s*(.*?)\s*<\/a/g,
            seller1: /Sold by[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            BSR_TABLE:
              /<table id="productDetails_detailBullets_sections1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE_TD: /<td>([\s\S]*?)<\/td>/gi,
            BSR_TABLE_TR: /<tr>([\s\S]*?)<\/tr>/gi,
            BSR_UL:
              /<ul class="a-unordered-list a-nostyle a-vertical a-spacing-none detail-bullet-list">([\s\S]*?)<\/ul>/gi,
            BSR_UL_children: /<li>([\s\S]*?)<\/li>/gi,
            ranking: /class="zg-badge-text">([\s\S]*?)</i,
            nation: /href='(.*?)'/gi,
            brandNation:
              /class="a-unordered-list a-nostyle a-vertical">([\s\S]*?)<\/ul>/,
            AmazonChoice: /<span class="ac-keyword-link">([\s\S]*?)<\/span>/gi,
            // motherland:/<a href=[\s\S]*?id="sellerProfileTriggerId">/
          },
        },
      },
    },
    /* CHINA 中国 */
    cn: {
      domain: "www.amazon.cn",
      supported: true,
      sales: false,
      ssl: true,
      currency: "￥",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },
          html: {
            products: /(<li id="result_[\s\S]*?<\/li>)/g,

            rank: /id="result_(.+?)"/gi,
            asin: /data-asin="(.*?)"/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            link: /href="(.*?)"/i,
            brand: /a-color-secondary"><\/span>.*?>(.*?)</gi,
            // price: /a-color-price.*?>.*?(\d*\.?\d+)/i,
            price: /a-text-price.*?>.*?(\d*\.?\d+)/i,
            rating: /a-icon-star.*?a-icon-alt.*?>平均([\d.,]*)/gi,
            reviews: /customerReviews.*?>([\d,]*)/gi,
            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            salesRank: /id="SalesRank"[\s\S]*?第([\d.,]*)名/gi,
            salesRank2: /亚马逊热销商品排名:[\s\S]*?第([\d.,]*)名/i,
            category: /查看(.*?)商品销售排行榜</i,
            category2: /-&nbsp;.*?>(.*?)</i,
            category3: /id="SalesRank"[\s\S]*?(.*?)商品里/i,
            category4: /亚马逊热销商品排名:[\s\S]*?(.*?)商品里/i,
            merchantInfo: /id="merchant-info[\s\S]*?>([\s\S]*?)<\/div/i,
            features: /id="feature-bullets[\s\S]*?>([\s\S]*?)<\/ul>/gi,

            features2: /<li>([\s\S]*?)<\/li>/gi,
            fba: /(isAmazonFulfilled=1)/i,
            amz: /(sold by Amazon.com)/i,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            price: /id="priceblock_[\s\S]*?￥([\d.,]*)(?:<| )/i,
            price2: /id="buybox[\s\S]*?a-color-price[\s\S]*?>￥([\d.,]*)</i,
            //price2: /a-color-price'.*￥(.*?)</i,
            price3: /offer-price.*?>￥(.*?)</i,
            variationsJson: /dimensionValuesDisplayData":({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,

            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
          },
        },
      },
    },
    /* UNITED STATES 美国 */
    com: {
      domain: "www.amazon.com",
      supported: true,
      sales: true,
      ssl: true,
      currency: "$",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },
          html: {
            lists: /(<li id="result_[\s\S]*?<\/li>)/g, //获取产品列表
            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /(".*?" data-index=[\s\S]*?data-asin=)/gi,
            products2: /(<li class="zg-item-immersion[\s\S]*?<\/li>)/gi,
            products3: / (class="zg_rankInfo[\s\S]*?)<\/a>/gi,

            multiList: /(<li class="a-carousel-card[\s\S]*?<\/li>)/g,
            rank: /id="result_(.+?)"/gi,
            asin: /"(.*?)" data-index=/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            title1: /<img[\s\S]*?alt="(.*?)"/gi,
            title3: /id="productTitle"[\s\S]*?<\/span>/gi,
            // title3: /id="productTitle"[\s\S]*?<\/span>/gi,
            titles: /<a[\s\S]*?<img alt="(.*?)"/i,
            link: /<a class="a-link-normal a-text-normal" href="(.*?)"/i,
            // link: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,
            link1: /title=.*?href="(.*?)"/gi,
            link2: /<a class="a-link-normal[\s\S]*?href="(.*?)"/gi,
            link3: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,
            brand: />by <\/span>[\s\S]*?>([\s\S]*?)</gi,
            brand2: /s-size-mild">(.*?)</gi,
            brand3: /<img alt="(.*?)" src/gi,
            brand4: />by (.*?)</gi,
            brandDetail: /id="bylineInfo.*?>(.*?)</gi,
            // price: /a-color-price.*?>.*?(\d*\.?\d+)/gi,
            price: /a-text-price.*?>.*?(\d*\.?\d+)/gi,
            price1: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,
            category: /class="a-text-bold">(.*?)<\/span>/i,
            rating: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)/gi,
            reviews: /<span class="a-size-base" dir="auto">(.*?)<\/span>/i,
            //reviews1: /customerReviews.*?>([\d,]*)<\/span>/i,
            //          reviews2: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            //          reviews3:/acrCustomerReviewText.*?>([\d,]*) customer reviews/i,
            // reviews4: /<a class="a-link-normal[\s\S]*?a-size-base">([\d,]*?)</ig,
            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName: /<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars: /<a class="a-link-normal" title="(.*?) /gi,
          date: /<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /<span data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count"[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            salesRank: /Rank[\s\S]*?#([\d.,]*) in .*?\(/i,
            salesRank1: /Rank[\s\S]*?#([\d.,]*) in .*?/i,
            salesRank2: /Rank[\s\S]*?#([\d.,]*) in ([\s\S]*?)/i,
            features: /id="feature-bullets[\s\S]*?>([\s\S]*?)<\/ul>/gi,
            features2: /<li>([\s\S]*?)<\/li>/gi,
            //salesRank3: /Rank[\s\S]*?#([\d.,]*) in ([\s\S]*?)/i,
            category: /Rank[\s\S]*?#[\d.,]* in (.*?) \(/i,
            // category: /<a class="a-link-normal a-color-tertiary" href=".*?">(.*?)<\/a>/,
            //category1: /Rank[\s\S]*?#[\d.,]* in (.*?) /i,
            category1:
              /Best Sellers Rank[\s\S]*?bestsellers[\s\S]*?>(.*?)<\/a>/gi,
            category2: /See Top\s*[\d.,]*\s*in\s*(.*?)<\/a/g,
            // category3: /<a class="a-link-normal a-color-tertiary" href=".*?">(.*?)<\/a>/,
            category3: /Cell Phones & Accessories/,
            //category2: /Rank[\s\S]*?#([\d.,]*) in .*?\(/i,
            //category3: /id="SalesRank"[\s\S]+?#(?:.+?) in (.*?) \(/i,
            //category4: /Best Sellers Rank[\s\S]*?#[\d.,]* in ([\s\S]*?)[\(|\<]/i,
            //category5: /class='nav-a nav-b'><span class="nav-a-content">(.*?)</i,  //add
            //
            merchantInfo: /class="a-size-base a-color-secondary a-nowrap"[\s\S]*?>([\s\S]*?)<\/span/i,
            merchantInfo1: /id="merchant-info[\s\S]*?>([\s\S]*?)<\/table/i,
            merchantInfo2: /id="merchant-info[\s\S]*?>([\s\S]*?)<\/table/i,
            weight:
              /(Pounds)|(Kilograms)|(kilogrammes)|(kilogramos)|(Grams)|(Kilogramm)|(Gramm)|(grammes)|(Ounces)|(Kg)|(grammi)|(gramos)/gi,

            is_adult:
              /(Erotic Massage Kits)|(Erotic Massagers & Vibrators)|(Bladder Control Devices)|(Appareils masturbateurs cup)|(Masseurs électriques portables)/,
            merchantInfo3:
              /id="freshShipsFromSoldBy_feature_div[\s\S]*?>([\s\S]*?)<\/div/i,
            title: /id="productTitle[\s\S]*?>([\s\S]*?)</i,
            fba: /(isAmazonFulfilled=1)/i,
            fba3: /id='sellerProfileTriggerId'[\s\S]*?<\/a>/gi,
            fba2: /class="tabular-buybox-text"[\s\S]*?<span class="a-size-small">[\s\S]*?<\/div>/gi,

            fbm: /(and sold by)/i,
            // amz: /(Amazon[\s\S]*?)/i,
            amz: /(by Amazon)|(by Amazon.com.)/gi,
            // amz: /<span class="tabular-buybox-text">Amazon.com<\/span>/,
            sponsored: /(Sponsored)/gi,
            date: /Date first[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            date1: /Date first[\s\S]*?<span>([\s\S]*?)<\/span>/i,
            //date2: /<span class="a-text-bold[\s\S]">Date First Available:<\/span><span>(.*?)<\/span>/g,
            date2: /Date First Available[\s\S]*?<span>([\s\S]*?)</g,
            // amz: /<span class="tabular-buybox-text">Amazon.com<\/span>/,

            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,

            price: /id="priceblock_[\s\S]*?\$(.*?)(?:<| )/i,
            price1:
              /id="desktop_buybox[\s\S]*?a-size-medium[\s\S]*?>\$(.*?)<\/span>/i,
            price2:
              /id="priceblock_ourprice[\s\S]*?priceBlockBuyingPriceString[\s\S]*?>(.*?)<\/span>/i,
            price3:
              /<span id="sns-base-price[\s\S]" class="a-size-medium a-color-price">\$(.*?)</i,
            price4:
              /class="a-price a-text-price a-size-medium apexPriceToPay"[\s\S]*?aria-hidden="true">([\s\S]*?)<\/span>/gi,
            price6: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,

            //price2: /id="priceblock_ourprice[\s\S]*?>\$(.*?)<\/span>/ig,
            //price3: /a-text-bold.*?>\$(.*?)</i,
            reviews: /id="acrCustomerReviewText.*?>([\d,]*)/i,
            //reviews1:/acrCustomerReviewText.*?>([\d,]*) customer reviews/i,
            // reviews2: /customerReviews.*?>([\d,]*)<\/span>/i,
            // reviews3: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            // reviews4::/acrCustomerReviewText.*?>([\d,]*) customer reviews/i
            variationsJson:
              /displayTypeProperties[\s\S]*"dimensionValuesDisplayData" : ({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,

            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
          },
          product_Details: {
            brandDetail: /<a id="bylineInfo.*?>(.*?)<\/a>/i,
            brandDetailUrl: /<a id="bylineInfo[\s\S]*?href="(.*?)">/i,
            keywords:
              /id="zg-right-col"[\s\S]*?<h1 class=[\s\S]*?class="category">(.*?)<\/span>/,
            soldBy: /<span class="tabular-buybox-text">([\s\S]*?)<\/span>/gi,
            coupon:
              /<td class="a-span12 a-color-price a-size-base">([\s\S]*?)<\/td>/,
            // seller:/<div class="a-box mbc-offer-row pa_mbc_on_amazon_offer">([\s\S]*?)<\/div>/,
            coupon3: /<span class="a-size-large a-color-price savingPriceOverride.*?>([\s\S]*?)<\/span>/gi,
            seller: /id=['"]sellerProfileTriggerId['"]>\s*(.*?)\s*<\/a/g,
            seller1: /Sold by[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            BSR_TABLE2:
              /<table id="productDetails_techSpec_section_1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE:
              /<table id="productDetails_detailBullets_sections1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE_TD: /<td>([\s\S]*?)<\/td>/gi,
            BSR_TABLE_TR: /<tr>([\s\S]*?)<\/tr>/gi,
            BSR_UL:
              /<ul class="a-unordered-list a-nostyle a-vertical a-spacing-none detail-bullet-list">([\s\S]*?)<\/ul>/gi,
            BSR_UL_children: /<li>([\s\S]*?)<\/li>/gi,
            ranking: /class="zg-badge-text">([\s\S]*?)</i,
            nation: /href='(.*?)'/gi,
            brandNation: /class="a-unordered-list a-nostyle a-vertical">([\s\S]*?)<\/ul>/,
            AmazonChoice: /<span class="ac-keyword-link">([\s\S]*?)<\/span>/gi,
            // motherland:/<a href=[\s\S]*?id="sellerProfileTriggerId">/
          },
        },
      },
    },
    /* GERMANY 德国 */
    de: {
      domain: "www.amazon.de",
      supported: true,
      sales: true,
      ssl: true,
      currency: "&euro;",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },
          html: {
            lists: /(<li id="result_[\s\S]*?<\/li>)/g, //获取产品列表
            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /(".*?" data-index=[\s\S]*?data-asin=)/gi,
            products2: /(role=[\s\S]*?class="zg-item-immersion")/gi,
            products3: /class="zg_item zg_homeWidgetItem"/gi,

            multiList: /(<li class="a-carousel-card[\s\S]*?<\/li>)/g,
            rank: /id="result_(.+?)"/gi,
            asin: /"(.*?)" data-index=/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            title3: /id="productTitle"[\s\S]*?<\/span>/gi,
            title1: /<img[\s\S]*?alt="(.*?)"/gi,
            titles: /<a[\s\S]*?<img alt="(.*?)"/i,
            link: /<a class="a-link-normal a-text-normal" href="(.*?)"/i,
            link1: /title=.*?href="(.*?)"/gi,
            link2: /<a class="a-link-normal[\s\S]*?href="(.*?)"/i,
            link3: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,

            brand: />von <\/span>.*?>(.*?)</gi,
            brandDetail: /id="bylineInfo.*?>(.*?)</i,
            // price: /<span class="a-price-whole">([\d,.]*)/i,
            // price1: /<span class="a-color-price">([\d,.]*)/i,
            // price2: /a-color-price.*?([\d,.]*)</i,
            price: /a-offscreen">*?([\d,.]*)</i,
            price1: /a-text-price.*?([\d,.]*)</i,
            price2: /a-price-whole">*?([\d,.]*)</i,
            rating: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)\s*out\s*of/gi,
            rating1: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)\s*von/gi,
            // rating1: /a-icon-alt">([\d,.]*)\s*out\s*of/gi,
            reviews: /customerReviews.*?>([\d,]*)/i,
            reviews1: /customerReviews.*?>([\d,]*)<\/span>/i,
            reviews2: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            reviews4:
              /<a class="a-link-normal[\s\S]*?a-size-base">([\d,]*?)</gi,
            reviews3:
              /id="cmrs-atf.*?>([\d,]*) Kundenrezensionen auf Amazon.com/gi,
            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName:
            /id="customer_review[\s\S]*?<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars:
            /id="customer_review[\s\S]*?<a class="a-link-normal" title="(.*?) /gi,
          date: /id="customer_review[\s\S]*?<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /<span data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count"[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            salesRank: /Nr. ([\d.,]*) in (.*?) \(/i,
            // salesRank1:
            //   /Amazon Bestseller-Rang[\s\S]*?<span>Nr. ([\d.,]*) in (.*?)</g,
            // salesRank2:
            //   /Amazon Bestseller-Rang[\s\S]*?Nr. ([\d.,]*) in (.*?)</g,
            salesRank1: /span>\s*([\d.,]*)\s*in\s*[^\)]<a/g,
            salesRank2: /Best Sellers Rank:\s*<\/span>\s*([\d.,]*)\s*in/g,
            //category: /<title>[\s\S]+?Amazon\.de: (.*?)</i,
            category: /Nr.\s*[\d.,]*\s*in\s*(.*?)\s*\(/i,
            // category1:/Amazon Bestseller-Rang[\s\S]*?bestsellers[\s\S]*?>(.*?)<\/a>/gi,
            // category1:/in <a[\s\S]*?>(.*?)<\/a>/gi,
            category1: /See Top\s*[\d.,]*\s*in\s*(.*?)<\/a/g,
            category2: /span>\s*[\d.,]*\s*in\s*(.*?)\s*[^\)]/g,
            category3: /span>\s*[\d.,]*\s*in\s*(.*?)\s*[^\)]<a/g,

            features: /id="feature-bullets[\s\S]*?>([\s\S]*?)<\/ul>/gi,

            features2: /<li>([\s\S]*?)<\/li>/gi,
            merchantInfo: /id="merchant-info[\s\S]*?>([\s\S]*?)<\/div/i,
            title: /id="productTitle[\s\S]*?>([\s\S]*?)</i,
            fba2: /class="tabular-buybox-text"[\s\S]*?<span class="a-size-small">[\s\S]*?<\/div>/gi,

            fba: /(isAmazonFulfilled=1)/i,
            amz: /(Verkauf und Versand durch Amazon.)/i,
            amz1: /(Verkauf und Bereitstellung durch Audible, ein Amazon Unternehmen)/i,
            amz2: /(Amazon UK[\s\S]*?)/i,
            fbm: /(Versand durch)/i,
            sponsored: /(Gesponsert)/g,
            // date: /Im Angebot von Amazon.de seit[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            // //date:/Im Angebot von Amazon.de seit.*?class="value">(.*?)</g,
            // date1: /Im Angebot von Amazon.de seit:<\/b>([\s\S]*?)</g,
            // date2: /Im Angebot von Amazon.de seit[\s\S]*?<span>([\s\S]*?)</g,
            date: /Date first[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            date1: /Date first[\s\S]*?<span>([\s\S]*?)<\/span>/i,
            date2: /Date First Available[\s\S]*?<span>([\s\S]*?)</g,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            price: /<span id="priceblock_.*?>(.*?)€</i,
            price1:
              /id="newBuyBoxPrice[\s\S]*?a-size-base[\s\S]*?>(.*?)€<\/span>/i,
            //price2: /class="a-lineitem[\s\S]*?priceblock_saleprice[\s\S]*?(.*?)€<\/span>/ig,
            price2:
              /id="buyNew_noncbb[\s\S]*?a-text-normal[\s\S]>(.*?)€<\/span>/gi,
            price3:
              /id="buyNewSection"[\s\S]*?a-text-normal[\s\S]*?>(.*?)€<\/span>/gi,
            price4:
              /class="a-price a-text-price a-size-medium apexPriceToPay"[\s\S]*?aria-hidden="true">([\s\S]*?)<\/span>/gi,
            price6: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,

            //price2: /<span id="priceblock_dealprice*?>(.*?)€</i,
            //price3: /a-text-bold.*?>\$(.*?)</i,
            //price4: /a-text-bold.*?>\$(.*?)</i,
            reviews: /id="acrCustomerReviewText".*?>(.*?)ratings<\/span/i,
            reviews1: /acrCustomerReviewText.*?>([\d,]*)/i,
            //reviews2: /customerReviews.*?>([\d,]*)<\/span>/i,
            //reviews3: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            //reviews4: /<a class="a-link-normal[\s\S]*?a-size-base">([\d,]*?)</ig,
            //reviews3:/id="cmrs-atf.*?>([\d,]*) Kundenrezensionen auf Amazon.com/ig,
            //price2: /a-color-price'.*\$(.*?)</i,
            //price3: /<span class="a-color-price">EUR ([\d.,]*)</i,
            //price3: /offer-price.*?>\$(.*?)</i,
            //price4: /priceLarge">EUR ([\d.,]*)</i,   //add
            variationsJson:
              /displayTypeProperties[\s\S]*"dimensionValuesDisplayData" : ({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,

            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
            weight:
              /(Pounds)|(Kilograms)|(kilogrammes)|(kilogramos)|(Grams)|(Kilogramm)|(Gramm)|(grammes)|(Ounces)|(Kg)|(grammi)|(gramos)/gi,
            is_adult:
              /(Erotic Massage Kits)|(Erotic Massagers & Vibrators)|(Bladder Control Devices)|(Appareils masturbateurs cup)|(Masseurs électriques portables)/,
          },
          product_Details: {
            brandDetail: /<a id="bylineInfo.*?>(.*?)<\/a>/i,
            brandDetailUrl: /<a id="bylineInfo[\s\S]*?href="(.*?)">/i,
            BSR_TABLE2:
              /<table id="productDetails_techSpec_section_1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            soldBy: /<span class="tabular-buybox-text">([\s\S]*?)<\/span>/gi,
            coupon:
              /<td class="a-span12 a-color-price a-size-base">([\s\S]*?)<\/td>/,
            coupon3: /<span class="a-size-large a-color-price savingPriceOverride.*?>([\s\S]*?)<\/span>/gi,
            // seller:
            //   /<div class="a-box mbc-offer-row pa_mbc_on_amazon_offer">([\s\S]*?)<\/div>/,
            seller: /id=['"]sellerProfileTriggerId['"]>\s*(.*?)\s*<\/a/g,
            // seller1:/sold\s*by\s*<\/span>.*?<span>\s*(.*?)\s*<\/span/g,
            seller1: /Sold by[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            BSR_TABLE:
              /<table id="productDetails_detailBullets_sections1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE_TD: /<td>([\s\S]*?)<\/td>/gi,
            BSR_TABLE_TR: /<tr>([\s\S]*?)<\/tr>/gi,
            BSR_UL:
              /<ul class="a-unordered-list a-nostyle a-vertical a-spacing-none detail-bullet-list">([\s\S]*?)<\/ul>/gi,
            BSR_UL_children: /<li>([\s\S]*?)<\/li>/gi,
            ranking: /class="zg-badge-text">([\s\S]*?)</i,
            nation: /href='(.*?)'/gi,
            brandNation:
              /class="a-unordered-list a-nostyle a-vertical">([\s\S]*?)<\/ul>/,
            AmazonChoice: /<span class="ac-keyword-link">([\s\S]*?)<\/span>/gi,
            // motherland:/<a href=[\s\S]*?id="sellerProfileTriggerId">/
          },
        },
      },
    },
    /* SPAIN 西班牙 */
    es: {
      domain: "www.amazon.es",
      supported: true,
      sales: true,
      ssl: true,
      currency: "&euro;",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },

          html: {
            bestsellers: /<ol id="zg-ordered-list"[\s\S]*?<\/ol>/,
            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /(".*?" data-index=[\s\S]*?data-asin=)/gi,
            products3: /class="zg_item zg_homeWidgetItem"/gi,
            products2: /<li [\s\S]*?<\/li>/g,

            multiList: /(<li class="a-carousel-card[\s\S]*?<\/li>)/g,
            rank: /id="result_(.+?)"/gi,
            asin: /"(.*?)" data-index=/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            title3: /id="productTitle"[\s\S]*?<\/span>/gi,
            title1: /<img[\s\S]*?alt="(.*?)"/gi,
            titles: /<a[\s\S]*?<img alt="(.*?)"/i,
            link: /<a class="a-link-normal a-text-normal" href="(.*?)"/i,
            link1: /title=.*?href="(.*?)"/gi,
            link2: /<a class="a-link-normal[\s\S]*?href="(.*?)"/i,
            link3: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,

            brand: />de <\/span>.*?>(.*?)</gi,
            brandDetail: /id="bylineInfo.*?>(.*?)</i,
            price: /<span class="a-offscreen">([\d,.]*)/i,
            // price1: /<span class="a-color-price">([\d,.]*)/i,
            price1: /a-text-price">([\d,.]*)/i,
            rating: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)/gi,
            reviews: /customerReviews.*?>([\d,]*)/gi,
            reviews1: /customerReviews.*?>([\d,]*)<\/span>/i,
            reviews2: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            reviews4:
              /<a class="a-link-normal[\s\S]*?a-size-base">([\d,]*?)</gi,
            reviews3:
              /acrCustomerReviewText.*?>([\d,]*) opiniones de clientes/i,
            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName:
            /id="customer_review[\s\S]*?<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars:
            /id="customer_review[\s\S]*?<a class="a-link-normal" title="(.*?) /gi,
          date: /id="customer_review[\s\S]*?<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /<span data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count"[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            salesRank:
              /Clasificación en los más vendidos de Amazon[\s\S]*?nº([\d.]*) en/gi,
            //salesRank1: /Clasificación en los más vendidos de Amazon[\s\S]*?nº([\d.,]*) en .*?\(/i,
            salesRank1:
              /Clasificación en los más vendidos de Amazon[\s\S]*?nº([\d.,]*) en .*?/gi,
            //salesRank2: /id="SalesRank"[\s\S]*?nº([\d.]*) en/ig,
            //salesRank2: /Clasificación en los más vendidos de Amazon:[\s\S]nº([\d.]*) en/i,
            //category: /Clasificación en los más vendidos de Amazon[\s\S]*?nº[\d.]* en([\s\S]*?) \(/ig,
            //category1: /dans&nbsp;.*?>(.*?)</i,
            category: /nº[\d.,]* en (.*?) \(/i,
            category1:
              /Clasificación en los más vendidos de Amazon[\s\S]*?bestsellers[\s\S]*?>(.*?)<\/a>/gi,
            //category2: /in&nbsp;.*?>(.*?)</i,
            //category3: /id="SalesRank"[\s\S]+?(?:.+?) en (.*?) \(/i,
            //category3: /id="SalesRank"[\s\S]+?#(?:.+?) in (.*?) \(/i,
            //category4: /Classement des meilleures ventes d'Amazon[\s\S]*?[\d.,]* en ([\s\S]*?) \(/i,
            //category4: /Best Sellers Rank[\s\S]*?#[\d.,]* in ([\s\S]*?) \(/i,
            //category5: /class='nav-a nav-b'><span class="nav-a-content">(.*?)</i,  //add
            // merchantInfo: /id="tabular-buybox[\s\S]*?>([\s\S]*?)<\/div/i,
            merchantInfo:
              /class="a-size-base a-color-secondary a-nowrap"[\s\S]*?>([\s\S]*?)<\/div/i,
            features: /id="feature-bullets[\s\S]*?>([\s\S]*?)<\/ul>/gi,
            price6: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,

            features2: /<li>([\s\S]*?)<\/li>/gi,
            title: /id="productTitle[\s\S]*?>([\s\S]*?)</i,
            sponsored: /(Sponsorisé)/i,

            date: /Producto en Amazon.es desde[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            date1:
              /Producto en Amazon.es desde[\s\S]*?<span>([\s\S]*?)<\/span>/i,
            //date:/Producto en Amazon.es desde.*?class="value">(.*?)</g,
            //date1:/Producto en Amazon.es desde:<\/b>([\s\S]*?)</g,
            // Envíos desde y vendidos por Sisbrill.
            fba: /(isAmazonFulfilled=1)/i,
            // fba: /( y envíos de )/i,
            fba2: /class="tabular-buybox-text"[\s\S]*?<span class="a-size-small">[\s\S]*?<\/div>/gi,

            fba3: /id='sellerProfileTriggerId'[\s\S]*?<\/a>/gi,
            weight:
              /(Pounds)|(Kilograms)|(kilogrammes)|(kilogramos)|(Grams)|(Kilogramm)|(Gramm)|(grammes)|(Ounces)|(Kg)|(grammi)|(gramos)/gi,
            is_adult:
              /(Erotic Massage Kits)|(Erotic Massagers & Vibrators)|(Bladder Control Devices)|(Appareils masturbateurs cup)|(Masseurs électriques portables)/,
            amz: /(Envíos desde y vendidos por Amazon.)/i,
            fbm: /( vendidos por )/i,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            // price: /<span id="priceblock_.*?>(.*?)€</i,
            price: /<span class="a-offscreen">([\d,.]*)/i,
            price1:
              /<span id="price_inside_buybox" class="a-size-medium a-color-price">(.*?)€</i,
            price2:
              /De 2ª mano:[\s\S]*?a-size-base a-color-price offer-price a-text-normal[\s\S]*?>(.*?)€<\/span>/gi,
            price3:
              /id="buyNewSection"[\s\S]*?a-text-normal[\s\S]*?>(.*?)€<\/span>/gi,
            price4:
              /class="a-price a-text-price a-size-medium apexPriceToPay"[\s\S]*?aria-hidden="true">([\s\S]*?)<\/span>/gi,
            reviews:
              /<span id="acrCustomerReviewText" class="a-size-base">(.*?) valoraciones</i,
            reviews1:
              /<span id="acrCustomerReviewText" class="a-size-base">(.*?) valoración</i,
            //price: /id="priceblock_[\s\S]*?EUR ([\d,]*)</i,
            //price2: /a-color-price.*?>.*?([\d,]*)</ig,
            //price3: /offer-price.*?>EUR(.*?)</i,
            variationsJson:
              /displayTypeProperties[\s\S]*"dimensionValuesDisplayData" : ({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,

            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
          },
          product_Details: {
            brandDetail: /<a id="bylineInfo.*?>(.*?)<\/a>/i,
            brandDetailUrl: /<a id="bylineInfo[\s\S]*?href="(.*?)">/i,
            BSR_TABLE2:
              /<table id="productDetails_techSpec_section_1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            soldBy: /<span class="tabular-buybox-text">([\s\S]*?)<\/span>/gi,
            coupon:
              /<td class="a-span12 a-color-price a-size-base">([\s\S]*?)<\/td>/,
            coupon3: /<span class="a-size-large a-color-price savingPriceOverride.*?>([\s\S]*?)<\/span>/gi,
            // seller:
            //   /<div class="a-box mbc-offer-row pa_mbc_on_amazon_offer">([\s\S]*?)<\/div>/,
            seller: /id=['"]sellerProfileTriggerId['"]>\s*(.*?)\s*<\/a/g,
            seller1: /Sold by[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            seller2: /Vendido por<\/span>[\s\S]*?class=['"]a-size-small[\s\S]*?['"][\s\S]*?>(.*?)<\/span/gi,
            BSR_TABLE:
              /<table id="productDetails_detailBullets_sections1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE_TD: /<td>([\s\S]*?)<\/td>/gi,
            BSR_TABLE_TR: /<tr>([\s\S]*?)<\/tr>/gi,
            BSR_UL:
              /<ul class="a-unordered-list a-nostyle a-vertical a-spacing-none detail-bullet-list">([\s\S]*?)<\/ul>/gi,
            BSR_UL_children: /<li>([\s\S]*?)<\/li>/gi,
            ranking: /class="zg-badge-text">([\s\S]*?)</i,
            nation: /href='(.*?)'/gi,
            brandNation:
              /class="a-unordered-list a-nostyle a-vertical">([\s\S]*?)<\/ul>/,
            AmazonChoice: /<span class="ac-keyword-link">([\s\S]*?)<\/span>/gi,
            // motherland:/<a href=[\s\S]*?id="sellerProfileTriggerId">/
          },
        },
      },
    },
    /* FRANCE 法国 */
    fr: {
      domain: "www.amazon.fr",
      supported: true,
      sales: true,
      ssl: true,
      currency: "&euro;",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },
          html: {
            bestsellers: /<ol id="zg-ordered-list"[\s\S]*?<\/ol>/,
            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /(".*?" data-index=[\s\S]*?data-asin=)/gi,
            // products2: /(role=[\s\S]*?class="zg-item-immersion")/gi,
            products2: /<li [\s\S]*?<\/li>/g,

            products3: /class="zg_item zg_homeWidgetItem"/gi,

            multiList: /(<li class="a-carousel-card[\s\S]*?<\/li>)/g,
            rank: /id="result_(.+?)"/gi,
            asin: /"(.*?)" data-index=/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            title3: /id="productTitle"[\s\S]*?<\/span>/gi,
            title1: /<img[\s\S]*?alt="(.*?)"/gi,
            titles: /<a[\s\S]*?<img alt="(.*?)"/i,
            link: /<a class="a-link-normal a-text-normal" href="(.*?)"/i,
            link1: /title=.*?href="(.*?)"/gi,
            link2: /<a class="a-link-normal[\s\S]*?href="(.*?)"/i,
            link3: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,

            brand: />de <\/span>.*?>(.*?)</gi,
            brandDetail: /id="bylineInfo.*?>(.*?)</i,
            price: /<span class="a-offscreen">([\d,.]*)/i,
            // price1: /<span class="a-color-price">([\d,.]*)/i,
            price1: /a-text-price">([\d,.]*)/i,
            rating: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)/gi,
            reviews: /customerReviews.*?>([\d,]*)/gi,
            reviews1: /customerReviews.*?>([\d,]*)<\/span>/i,
            reviews2: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            reviews4:
              /<a class="a-link-normal[\s\S]*?a-size-base">([\d,]*?)</gi,
            reviews3: /acrCustomerReviewText.*?>([\d,]*) commentaire client/i,
            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName:
            /id="customer_review[\s\S]*?<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars:
            /id="customer_review[\s\S]*?<a class="a-link-normal" title="(.*?) /gi,
          date: /id="customer_review[\s\S]*?<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /<span data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count"[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            salesRank:
              /Classement des meilleures ventes d'Amazon[\s\S]*?([\d.,]*) en/i,
            //salesRank: /id="SalesRank"[\s\S]*?([\d.]*) en/ig,
            //salesRank2: /Classement des meilleures ventes d'Amazon[\s\S]*?([\d.]*) en/i,
            //salesRank3: /Classement des meilleures ventes d'Amazon[\s\S]*?([\d.]*) dans la/i,
            category:
              /Classement des meilleures ventes d'Amazon[\s\S]*?[\d.,]* en ([\s\S]*?) \(/i,
            category1:
              /Classement des meilleures ventes d'Amazon[\s\S]*?bestsellers[\s\S]*?>(.*?)<\/a>/gi,
            //category: /<title>[\s\S]+?Amazon\.fr: (.*?)</i,
            //category2: /dans&nbsp;.*?>(.*?)</i,
            //category2: /in&nbsp;.*?>(.*?)</i,
            //category3: /id="SalesRank"[\s\S]+?(?:.+?) en (.*?) \(/i,
            //category3: /id="SalesRank"[\s\S]+?#(?:.+?) in (.*?) \(/i,
            //category4: /Classement des meilleures ventes d'Amazon[\s\S]*?[\d.,]* en ([\s\S]*?) \(/i,
            //category4: /Best Sellers Rank[\s\S]*?#[\d.,]* in ([\s\S]*?) \(/i,
            //category5: /class='nav-a nav-b'><span class="nav-a-content">(.*?)</i,  //add
            // merchantInfo: /id="tabular-buybox[\s\S]*?>([\s\S]*?)<\/div/i,
            merchantInfo:
              /class="a-size-base a-color-secondary a-nowrap"[\s\S]*?>([\s\S]*?)<\/div/i,
            features: /id="feature-bullets[\s\S]*?>([\s\S]*?)<\/ul>/gi,
            features2: /<li>([\s\S]*?)<\/li>/gi,
            fba2: /class="tabular-buybox-text"[\s\S]*?<span class="a-size-small">[\s\S]*?<\/div>/gi,

            fba: /id='sellerProfileTriggerId'[\s\S]*?<\/a>/gi,
            amz: /(Expédié et vendu par Amazon.)/i,
            fbm: /(Expédié et vendu par)/i,

            title: /id="productTitle[\s\S]*?>([\s\S]*?)</i,
            sponsored: /(Sponsorisé)/i,
            date: /Date de mise en ligne sur Amazon.fr.*?class="value">(.*?)</g,
            date1: /Date de mise en ligne sur Amazon.fr:<\/b>([\s\S]*?)</g,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            price: /<span id="priceblock_.*?>(.*?)€</i,
            price1:
              /id="corePrice_feature_div"[\s\S]*?<span class="a-offscreen">([\s\S]*?)<\/span>/i,

            price2:
              /<span class="a-size-medium a-color-price offer-price a-text-normal.*?>(.*?)€</i,
            price4:
              /<span id="price_inside_buybox" class="a-size-medium a-color-price">([\s\S]*?)<\/span>/i,
            price3:
              /id="buyNew_noncbb[\s\S]*?a-text-normal[\s\S]>(.*?)€<\/span>/gi,
            date: /Date de mise en ligne[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            price6: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,
            date1: /Date de mise en ligne[\s\S]*?<span>([\s\S]*?)<\/span>/i,
            reviews: /acrCustomerReviewText.*?>([\d,]*) évaluations/i,
            reviews1:
              /<span id="acrCustomerReviewText" class="a-size-base">(.*?)évaluations</i,
            reviews2:
              /<span id="acrCustomerReviewText[\s\S].*?>(.*?)évaluation<\/span>/gi,
            //reviews2: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            variationsJson:
              /displayTypeProperties[\s\S]*"dimensionValuesDisplayData" : ({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,
            weight:
              /(Pounds)|(Kilograms)|(kilogrammes)|(kilogramos)|(Grams)|(Kilogramm)|(Gramm)|(grammes)|(Ounces)|(Kg)|(grammi)|(gramos)/gi,
            is_adult:
              /(Erotic Massage Kits)|(Erotic Massagers & Vibrators)|(Bladder Control Devices)|(Appareils masturbateurs cup)|(Masseurs électriques portables)/,
            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
          },
          product_Details: {
            brandDetail: /<a id="bylineInfo.*?>(.*?)<\/a>/i,
            brandDetailUrl: /<a id="bylineInfo[\s\S]*?href="(.*?)">/i,
            BSR_TABLE2:
              /<table id="productDetails_techSpec_section_1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            soldBy: /<span class="tabular-buybox-text">([\s\S]*?)<\/span>/gi,
            coupon:
              /<td class="a-span12 a-color-price a-size-base priceBlockSavingsString">([\s\S]*?)<\/td>/,
            coupon2:
              /class="a-color-price"[\s\S]*?class="a-price a-text-price a-size-base[\s\S]*?data-a-color="price">([\s\S]*?)<span id="bundleLTBSSavings_feature_div"/,
            coupon3: /<span class="a-size-large a-color-price savingPriceOverride.*?>([\s\S]*?)<\/span>/gi,
            // seller:
            //   /<div class="a-box mbc-offer-row pa_mbc_on_amazon_offer">([\s\S]*?)<\/div>/,
            seller: /id=['"]sellerProfileTriggerId['"]>\s*(.*?)\s*<\/a/g,
            seller1: /Sold by[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            seller2: /Vendu par<\/span>[\s\S]*?class=['"]a-size-small[\s\S]*?['"][\s\S]*?>(.*?)<\/span/gi,
            BSR_TABLE:
              /<table id="productDetails_detailBullets_sections1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE_TD: /<td>([\s\S]*?)<\/td>/gi,
            BSR_TABLE_TR: /<tr>([\s\S]*?)<\/tr>/gi,
            BSR_UL:
              /<ul class="a-unordered-list a-nostyle a-vertical a-spacing-none detail-bullet-list">([\s\S]*?)<\/ul>/gi,
            BSR_UL_children: /<li>([\s\S]*?)<\/li>/gi,
            ranking: /class="zg-badge-text">([\s\S]*?)</i,
            nation: /href='(.*?)'/gi,
            brandNation:
              /class="a-unordered-list a-nostyle a-vertical">([\s\S]*?)<\/ul>/,
            AmazonChoice: /<span class="ac-keyword-link">([\s\S]*?)<\/span>/gi,
            // motherland:/<a href=[\s\S]*?id="sellerProfileTriggerId">/
          },
        },
      },
    },
    /* INDIA 印度 */
    in: {
      domain: "www.amazon.in",
      supported: true,
      sales: false,
      ssl: false,
      currency: "&#8377;",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },
          html: {
            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /data-index=([\s\S]*?)data-asin/g,
            products2: /(role=[\s\S]*?class="zg-item-immersion")/gi,
            products3: /class="zg_item zg_homeWidgetItem"/gi,

            rank: /id="result_(.+?)"/gi,
            asin: /data-asin="(.*?)"/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            link: /href="(.*?)"/i,
            link2: /<a class="a-link-normal[\s\S]*?href="(.*?)"/i,
            link3: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,

            brand: />by <\/span>.*?>(.*?)</gi,
            // price: /a-color-price.*?currencyINR">.*?>([\d.,]*)/gi,
            price: /a-text-price.*?currencyINR">.*?>([\d.,]*)/gi,
            rating: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)/gi,
            reviews: /customerReviews.*?>([\d,]*)/gi,
            sellersNew: /condition=new(?:.*?)(\d+) offers/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName:
            /id="customer_review[\s\S]*?<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars:
            /id="customer_review[\s\S]*?<a class="a-link-normal" title="(.*?) /gi,
          date: /id="customer_review[\s\S]*?<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /<span data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count"[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            salesRank: /id="SalesRank"[\s\S]*?#([\d.,]*) in/gi,
            salesRank2: /Best Sellers Rank[\s\S]*?#([\d.,]*) in/i,
            category: /See Top 100 in (.*?)</i,
            category2: /in&nbsp;.*?>(.*?)</i,
            category3: /id="SalesRank"[\s\S]+?#(?:.+?) in (.*?) \(/i,
            category4: /Best Sellers Rank[\s\S]*?#[\d.,]* in ([\s\S]*?) \(/i,
            category5:
              /class='nav-a nav-b'><span class="nav-a-content">(.*?)</i, //add
            merchantInfo: /id="merchant-info[\s\S]*?>([\s\S]*?)<\/div/i,
            fba: /(isAmazonFulfilled=1)/i,
            amz: /(sold by Amazon.com)/i,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            price: /id="priceblock_[\s\S]*?<\/span>[\s]*([\d.,]*)/i,
            price2: /id="buybox[\s\S]*?a-color-price[\s\S]*?> ([\d.,]*)</i,
            //price2: /a-color-price'.*\$(.*?)</i,
            price3: /offer-price.*?> ([\d.,]*)</i,
            price6: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,

            variationsJson: /dimensionValuesDisplayData":({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,
            weight:
              /(Pounds)|(Kilograms)|(kilogrammes)|(kilogramos)|(Grams)|(Kilogramm)|(Gramm)|(grammes)|(Ounces)|(Kg)|(grammi)|(gramos)/gi,
            is_adult:
              /(Erotic Massage Kits)|(Erotic Massagers & Vibrators)|(Bladder Control Devices)|(Appareils masturbateurs cup)|(Masseurs électriques portables)/,
            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
          },
        },
      },
    },
    /* ITALY 意大利 */
    it: {
      domain: "www.amazon.it",
      supported: true,
      sales: true,
      ssl: true,
      currency: "&euro;",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },
          html: {
            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /(".*?" data-index=[\s\S]*?data-asin=)/gi,
            products2: /(role=[\s\S]*?class="zg-item-immersion")/gi,
            products3: /class="zg_item zg_homeWidgetItem"/gi,

            multiList: /(<li class="a-carousel-card[\s\S]*?<\/li>)/g,
            rank: /id="result_(.+?)"/gi,
            asin: /"(.*?)" data-index=/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            title1: /<img[\s\S]*?alt="(.*?)"/gi,
            title3: /id="productTitle"[\s\S]*?<\/span>/gi,
            titles: /<a[\s\S]*?<img alt="(.*?)"/i,
            link: /<a class="a-link-normal a-text-normal" href="(.*?)"/i,
            link1: /title=.*?href="(.*?)"/gi,
            link2: /<a class="a-link-normal[\s\S]*?href="(.*?)"/i,
            link3: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,

            brand: />di <\/span>.*?>(.*?)</gi,
            brandDetail: /id="bylineInfo.*?>(.*?)</i,
            price: /<span class="a-offscreen">([\d,.]*)/i,
            // price1: /<span class="a-color-price">([\d,.]*)/i,
            price1: /a-text-price">([\d,.]*)/i,
            rating: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)/gi,
            reviews: /customerReviews.*?>([\d,]*)/gi,
            reviews1: /customerReviews.*?>([\d,]*)<\/span>/i,
            reviews2: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            reviews4:
              /<a class="a-link-normal[\s\S]*?a-size-base">([\d,]*?)</gi,
            reviews3: /acrCustomerReviewText.*?>([\d,]*) recensioni clienti/i,
            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName:
            /id="customer_review[\s\S]*?<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars:
            /id="customer_review[\s\S]*?<a class="a-link-normal" title="(.*?) /gi,
          date: /id="customer_review[\s\S]*?<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /<span data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count"[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            salesRank:
              /Posizione nella classifica Bestseller di Amazon[\s\S]*?n. ([\d.]*) in/i,
            //salesRank1: /id="SalesRank"[\s\S]*?([\d.]*) in/ig,
            salesRank1:
              /Posizione nella classifica Bestseller di Amazon[\s\S]*?n. ([\d.,]*) in .*?/gi,
            //salesRank2: /Posizione nella classifica Bestseller di Amazon[\s\S]*?n. ([\d.]*) in/i,
            category:
              /Posizione nella classifica Bestseller di Amazon[\s\S]*?[\d.,]* in ([\s\S]*?) \(/i,
            category1: /n.[\d.,]* in (.*?) \(/i,
            reviews: /acrCustomerReviewText.*?>(.*?)voti/i,
            //reviews1: /<span id="acrCustomerReviewText" class="a-size-base[\s\S]*?([\d,]*?) voti</ig,
            //category: /<title>[\s\S]+?Amazon\.it: (.*?)</i,
            //category2: /dans&nbsp;.*?>(.*?)</i,
            //category2: /in&nbsp;.*?>(.*?)</i,
            //category3: /id="SalesRank"[\s\S]+?(?:.+?) in (.*?) \(/i,
            //category3: /id="SalesRank"[\s\S]+?#(?:.+?) in (.*?) \(/i,
            //category4: /Posizione nella classifica Bestseller di Amazon[\s\S]*?[\d.,]* in ([\s\S]*?) \(/i,
            //category4: /Best Sellers Rank[\s\S]*?#[\d.,]* in ([\s\S]*?) \(/i,
            //category5: /class='nav-a nav-b'><span class="nav-a-content">(.*?)</i,  //add
            // merchantInfo: /id="tabular-buybox[\s\S]*?>([\s\S]*?)<\/div/i,
            merchantInfo:
              /class="a-size-base a-color-secondary a-nowrap"[\s\S]*?>([\s\S]*?)<\/div/i,
            title: /id="productTitle[\s\S]*?>([\s\S]*?)</i,
            amz: /(Venduto e spedito da Amazon)/i,
            fba2: /class="tabular-buybox-text"[\s\S]*?<span class="a-size-small">[\s\S]*?<\/div>/gi,
            features: /id="feature-bullets[\s\S]*?>([\s\S]*?)<\/ul>/gi,

            features2: /<li>([\s\S]*?)<\/li>/gi,
            fba3: /id='sellerProfileTriggerId'[\s\S]*?<\/a>/gi,
            fba: /(isAmazonFulfilled=1)/gi,
            fbm: /(Venduto e spedito da)/i,
            sponsored: /(Sponsorizzato)/i,
            //date:/Disponibile su Amazon.it a partire dal.*?class="value">(.*?)</g,
            //date1:/Disponibile su Amazon.it a partire dal:<\/b>([\s\S]*?)</g,
            date: /Disponibile su Amazon.it a partire dal[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            date1:
              /Disponibile su Amazon.it a partire dal[\s\S]*?<span>([\s\S]*?)<\/span>/i,
            //date2: /Disponibile su Amazon.it a partire dal[\s\S]*?<span>([\s\S]*?)</g,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            //price: /<span id="priceblock_.*?>(. *?)€</i,
            price1:
              /id="corePrice_feature_div"[\s\S]*?<span class="a-offscreen">([\s\S]*?)<\/span>/i,
            price2:
              /<span id="price_inside_buybox" class="a-size-medium a-color-price">([\s\S]*?)<\/span>/i,
            price:
              /id="priceblock_[\s\S]*?a-color-price[\s\S]*?>(.*?)€<\/span>/gi,
            price3:
              /id="buyNew_noncbb[\s\S]*?a-text-normal[\s\S]>(.*?)€<\/span>/gi,
            price4:
              /id="buyNewSection"[\s\S]*?a-text-normal[\s\S]*?>(.*?)€<\/span>/gi,
            weight:
              /(Pounds)|(Kilograms)|(kilogrammes)|(kilogramos)|(Grams)|(Kilogramm)|(Gramm)|(grammes)|(Ounces)|(Kg)|(grammi)|(gramos)/gi,
            is_adult:
              /(Erotic Massage Kits)|(Erotic Massagers & Vibrators)|(Bladder Control Devices)|(Appareils masturbateurs cup)|(Masseurs électriques portables)/,
            variationsJson:
              /displayTypeProperties[\s\S]*"dimensionValuesDisplayData" : ({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,

            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
          },
          product_Details: {
            brandDetail: /<a id="bylineInfo.*?>(.*?)<\/a>/i,
            brandDetailUrl: /<a id="bylineInfo[\s\S]*?href="(.*?)">/i,
            BSR_TABLE2:
              /<table id="productDetails_techSpec_section_1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            soldBy: /<span class="tabular-buybox-text">([\s\S]*?)<\/span>/gi,
            coupon:
              /<td class="a-span12 a-color-price a-size-base">([\s\S]*?)<\/td>/,
            coupon3: /<span class="a-size-large a-color-price savingPriceOverride.*?>([\s\S]*?)<\/span>/gi,
            // seller:
            //   /<div class="a-box mbc-offer-row pa_mbc_on_amazon_offer">([\s\S]*?)<\/div>/,
            seller: /id=['"]sellerProfileTriggerId['"]>\s*(.*?)\s*<\/a/g,
            seller1: /Sold by[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            seller2: /Venditore<\/span>[\s\S]*?class=['"]a-size-small[\s\S]*?['"][\s\S]*?>(.*?)<\/span/gi,
            BSR_TABLE:
              /<table id="productDetails_detailBullets_sections1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,

            BSR_TABLE_TD: /<td>([\s\S]*?)<\/td>/gi,
            BSR_TABLE_TR: /<tr>([\s\S]*?)<\/tr>/gi,
            BSR_UL:
              /<ul class="a-unordered-list a-nostyle a-vertical a-spacing-none detail-bullet-list">([\s\S]*?)<\/ul>/gi,
            BSR_UL_children: /<li>([\s\S]*?)<\/li>/gi,
            ranking: /class="zg-badge-text">([\s\S]*?)</i,
            nation: /href='(.*?)'/gi,
            brandNation:
              /class="a-unordered-list a-nostyle a-vertical">([\s\S]*?)<\/ul>/,
            AmazonChoice: /<span class="ac-keyword-link">([\s\S]*?)<\/span>/gi,
            // motherland:/<a href=[\s\S]*?id="sellerProfileTriggerId">/
          },
        },
      },
    },
    /* JAPAN 日本 */
    jp: {
      domain: "www.amazon.co.jp",
      supported: true,
      sales: true,
      ssl: true,
      currency: "￥",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
            keywords1: /k=(.+?)(?:&|$)/i,
          },
          html: {
            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /(".*?" data-index=[\s\S]*?data-asin=)/gi,
            products2: /(role=[\s\S]*?class="zg-item-immersion")/gi,
            products3: /class="zg_item zg_homeWidgetItem"/gi,

            rank: /id="result_(.+?)"/gi,
            asin: /"(.*?)" data-index=/gi,// /data-asin="(.*?)"/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            title1: /<span[\s\S]*?a-text-normal">(.*?)<\/span>/gi,
            link: /href="(.*?)"[\s\S]*?>/i,
            link1: /href="(.*?)"[\s\S]*?>/i,
            link2: /href="(.*?)"[\s\S]*?>/i,
            link3: /href="(.*?)"[\s\S]*?>/i,
            brand: /a-color-secondary"><\/span>.*?>(.*?)<\/span/gi,
            // brandDetail:/<tr[\s\S]*?po-brand">[\s\S]*?a-size-base">(.*?)<\/span>/gi,//---------------------------
            brandDetail: /id="bylineInfo.*?>(.*?)</gi,
            // price: /a-color-price.*?>.*?([\d.,]*)</gi,
            price: /a-text-price.*?>.*?([\d.,]*)</gi,
            price1: /<span[\s\S]*?a-price-whole">(.*?)<\/span>/gi,
            category: /class="a-text-bold">(.*?)<\/span>/i,
            // rating: /a-icon-star.*?a-icon-alt.*?>5つ星のうち ([\d.,]*)/gi,
            rating: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)\s*out\s*of/gi,
            rating1: /a-icon-star.*?a-icon-alt.*?>([\d.,]*)\s*von/gi,
            reviews: /customerReviews.*?>([\d,]*)/gi,
            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName: /<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars: /<a class="a-link-normal" title="(.*?) /gi,
          date: /<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /<span data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count"[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          html: {
            // salesRank: /id="- ([\d,]*)位/gi,
            salesRank: /Rank[\s\S]*?#([\d.,]*) in .*?\(/i,
            salesRank1: /Rank[\s\S]*?#([\d.,]*) in .*?/i,
            salesRank2: /Rank[\s\S]*?#([\d.,]*) in ([\s\S]*?)/i,
            sponsored: /(Sponsored)/g,
            //salesRank: /id="SalesRank"[\s\S]*?- ([\d,]*)/ig,
            // salesRank2: /Amazon 売れ筋ランキング[\s\S]*?\- ([\d,]*)/i,
            brandDetail: /<tr[\s\S]*?po-brand">[\s\S]*?a-size-base">(.*?)<\/span>/gi,//---------------------------
            // category: /id="SalesRank"[\s\S]+?(.*?) -/i,
            category: /See Top\s*[\d.,]*\s*in\s*(.*?)<\/a/g,//---------------------------
            category2: /─&nbsp;.*?>(.*?)</i,
            category3: /Amazon 売れ筋ランキング[\s\S]*?([\s\S]*?) -/i,
            category4: /<option[\s\S]*?selected="selected"[\s\S]*?>(.*?)</i,
            reviews: /acrCustomerReviewText.*?>([\d,]*) ratings/i,
            reviews1: /<span id="acrCustomerReviewText[\s\S].*?>(.*?)rating<\/span>/gi,
            merchantInfo: /id="merchant-info[\s\S]*?>([\s\S]*?)<\/div/i,
            fba: /(isAmazonFulfilled=1)/i,
            amz: /(sold by Amazon.com)/i,
            fbm: /(sold by)/i,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            price: /id="priceblock_[\s\S]*?￥ ([\d.,]*)</i,
            price2: /id="buybox[\s\S]*?a-color-price[\s\S]*?>￥ ([\d.,]*)</i,
            //price2: /a-color-price'.*￥ (.*?)</i,
            price3: /offer-price.*?>￥ (.*?)</i,
            variationsJson: /dimensionValuesDisplayData":({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,

            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
            date: /Date first[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            date1: /Date first[\s\S]*?<span>([\s\S]*?)<\/span>/i,
            date2: /Date First Available[\s\S]*?<span>([\s\S]*?)</g,
          },
          product_Details: {
            brandDetail: /<a id="bylineInfo.*?>(.*?)<\/a>/i,
            brandDetailUrl: /<a id="bylineInfo[\s\S]*?href="(.*?)">/i,
            keywords:
              /id="zg-right-col"[\s\S]*?<h1 class=[\s\S]*?class="category">(.*?)<\/span>/,
            soldBy: /<span class="tabular-buybox-text">([\s\S]*?)<\/span>/gi,
            coupon: /<td class="a-span12 a-color-price a-size-base">([\s\S]*?)<\/td>/,
            coupon3: /<span class="a-size-large a-color-price savingPriceOverride.*?>([\s\S]*?)<\/span>/gi,
            // seller:/<div class="a-box mbc-offer-row pa_mbc_on_amazon_offer">([\s\S]*?)<\/div>/,
            seller: /id=['"]sellerProfileTriggerId['"]>\s*(.*?)\s*<\/a/g,
            seller1: /Sold by[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            BSR_TABLE2:
              /<table id="productDetails_techSpec_section_1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE:
              /<table id="productDetails_detailBullets_sections1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE_TD: /<td>([\s\S]*?)<\/td>/gi,
            BSR_TABLE_TR: /<tr>([\s\S]*?)<\/tr>/gi,
            BSR_UL:
              /<ul class="a-unordered-list a-nostyle a-vertical a-spacing-none detail-bullet-list">([\s\S]*?)<\/ul>/gi,
            BSR_UL_children: /<li>([\s\S]*?)<\/li>/gi,
            ranking: /class="zg-badge-text">([\s\S]*?)</i,
            nation: /href='(.*?)'/gi,
            brandNation: /class="a-unordered-list a-nostyle a-vertical">([\s\S]*?)<\/ul>/,
            AmazonChoice: /<span class="ac-keyword-link">([\s\S]*?)<\/span>/gi,
            // motherland:/<a href=[\s\S]*?id="sellerProfileTriggerId">/
          },
        },
      },
    },
    /* UNITED KINGDOM 英国 */
    uk: {
      domain: "www.amazon.co.uk",
      supported: true,
      sales: true,
      ssl: true,
      currency: "&pound;",
      regex: {
        search: {
          url: {
            domain: /:\/\/(.*?)\//i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            keywords1: /k=(.+?)(?:&|$)/i,
            page: /&page=[\d]*/i,
          },
          html: {
            bestsellers: /<ol id="zg-ordered-list"[\s\S]*?<\/ol>/,
            products: /(<li id="result_[\s\S]*?<\/li>)/g,
            products1: /(".*?" data-index=[\s\S]*?data-asin=)/gi,
            // products2: /(role=[\s\S]*?class="zg-item-immersion")/gi,
            products2: /<li [\s\S]*?<\/li>/g,
            products3: /class="zg_item zg_homeWidgetItem"/gi,

            multiList: /(<li class="a-carousel-card[\s\S]*?<\/li>)/g,
            rank: /id="result_(.+?)"/gi,
            asin: /"(.*?)" data-index=/gi,
            image: /<img.*?src="(.*?)"/gi,
            title: /title="(.*?)"/gi,
            title3: /id="productTitle"[\s\S]*?<\/span>/gi,
            title1: /<img[\s\S]*?alt="(.*?)"/gi,
            titles: /<a[\s\S]*?<img alt="(.*?)"/i,
            link: /<a class="a-link-normal a-text-normal" href="(.*?)"/i,
            link1: /title=.*?href="(.*?)"/gi,
            link2: /<a class="a-link-normal[\s\S]*?href="(.*?)"/i,
            link3: /<a class="a-link-normal s-no-outline" href="(.*?)"/i,

            brand: />by <\/span>.*?>(.*?)</gi,
            brandDetail: /id="bylineInfo.*?>(.*?)</i,
            price: /<span class="a-offscreen">\£([\d,.]*)/i,
            // price1: /<span class="a-color-price">\£([\d,.]*)/i,
            price1: /a-text-price">\£([\d,.]*)/i,
            rating: /a-icon-star[\s\S]*?a-icon-alt.*?>([\d.,]*) out/gi,
            reviews: /customerReviews.*?>([\d,]*)/gi,
            reviews1: /customerReviews.*?>([\d,]*)<\/span>/i,
            reviews2: /a-size-small a-link-normal.*?>([\d,]*)<\/a>/i,
            reviews4:
              /<a class="a-link-normal[\s\S]*?a-size-base">([\d,]*?)</gi,
            reviews3: /acrCustomerReviewText.*?>([\d,]*) customer reviews/i,
            sellersNew: /condition=new(?:.*?)\((\d+)/i,
            sellersUsed: /condition=used(?:.*?)\((\d+)/i,
          },
        },
        comments: {
          userName:
            /id="customer_review[\s\S]*?<span class="a-profile-name">([\s\S]*?)<\/span>/gi,
          homeLink: /data-hook="genome-widget"[\s\S]*?href="(.*?)"/gi,
          stars:
            /id="customer_review[\s\S]*?<a class="a-link-normal" title="(.*?) /gi,
          date: /id="customer_review[\s\S]*?<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          verify: /data-hook="avp-badge"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review: /data-hook="review-body"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_title:
            /data-hook="review-title"[\s\S]*?<span>([\s\S]*?)<\/span>/gi,
          review_Link: /data-hook="review-title"[\s\S]*?href="(.*?)"/gi,
          variant: /data-hook="format-strip"[\s\S]*?>([\s\S]*?)<\/a>/gi,
          helpful: /data-reftag="cm_cr_arp_d_cmt_opn"[\s\S]*?<\/div>/gi,
          helpful2:
            /<span data-hook="helpful-vote-statement"[\s\S]*?>([\s\S]*?)<\/span>/gi,
          review_rating:
            /data-hook="cr-filter-info-review-rating-count"[\s\S]*?>([\s\S]*?)<\/span>/gi,
        },
        product: {
          url: {
            domain: /:\/\/(.*?)\//i,
            asin: /\/dp\/(.+?)(?:\/|$)+/i,
            keywords: /keywords=(.+?)(?:&|$)/i,
            canonical: /:\/\/.*?\/(.*?)\//i,
          },
          product_Details: {
            brandDetail: /<a id="bylineInfo.*?>(.*?)<\/a>/i,
            brandDetailUrl: /<a id="bylineInfo[\s\S]*?href="(.*?)">/i,
            BSR_TABLE2:
              /<table id="productDetails_techSpec_section_1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            soldBy: /<span class="tabular-buybox-text">([\s\S]*?)<\/span>/gi,
            coupon:
              /<td class="a-span12 a-color-price a-size-base priceBlockSavingsString">([\s\S]*?)<\/td>/,
            coupon2:
              /<td class="a-span12 a-color-price a-size-base">([\s\S]*?)<\/td>/,
            coupon3: /<span class="a-size-large a-color-price savingPriceOverride.*?>([\s\S]*?)<\/span>/gi,
            // seller:
            //   /<div class="a-box mbc-offer-row pa_mbc_on_amazon_offer">([\s\S]*?)<\/div>/,
            seller: /id=['"]sellerProfileTriggerId['"]>\s*(.*?)\s*<\/a/g,
            seller1: /Sold by[\s\S]*?class=['"]a-link-normal['"][\s\S]*?>[\s\S]*?<span>\s*(.*?)\s*<\/span/gi,
            BSR_TABLE:
              /<table id="productDetails_detailBullets_sections1" class="a-keyvalue prodDetTable" role="presentation">([\s\S]*?)<\/table>/gi,
            BSR_TABLE_TD: /<td>([\s\S]*?)<\/td>/gi,
            BSR_TABLE_TR: /<tr>([\s\S]*?)<\/tr>/gi,
            BSR_UL:
              /<ul class="a-unordered-list a-nostyle a-vertical a-spacing-none detail-bullet-list">([\s\S]*?)<\/ul>/gi,
            BSR_UL_children: /<li>([\s\S]*?)<\/li>/gi,
            ranking: /class="zg-badge-text">([\s\S]*?)</i,
            nation: /href='(.*?)'/gi,
            brandNation:
              /class="a-unordered-list a-nostyle a-vertical">([\s\S]*?)<\/ul>/,
            AmazonChoice: /<span class="ac-keyword-link">([\s\S]*?)<\/span>/gi,
            // motherland:/<a href=[\s\S]*?id="sellerProfileTriggerId">/
          },

          html: {
            salesRank: /Best Sellers Rank:[\s\S]*?([\d.,]*) in .*?/i,
            salesRank1: /Rank[\s\S]*?([\d.,]*) in .*? \(/g,
            //salesRank2: /Rank[\s\S]*?#([\d.,]*) Free in .*? \(/g,
            salesRank2: /Best Sellers Rank[\s\S]*?([\d.,]*) in .*?/gi,
            salesRank3: /<span>([\s\S]*?([\d.,]*)) in Beauty .*? \(/gi,
            features: /id="feature-bullets[\s\S]*?>([\s\S]*?)<\/ul>/gi,

            features2: /<li>([\s\S]*?)<\/li>/gi,
            category: /Rank[\s\S]*?[\d.,]* in (.*?) \(/g,
            category1:
              /Best Sellers Rank:[\s\S]*?bestsellers[\s\S]*?>(.*?)<\/a>/gi,
            category2: /Best Sellers Rank[\s\S]*?[\d.,]* in ([\s\S]*?) \(/i,

            //category3: /id="SalesRank"[\s\S]+?#(?:.+?) in (.*?) \(/i,
            //category4: /Best Sellers Rank[\s\S]*?#[\d.,]* in ([\s\S]*?) \(/i,
            //category5: /class='nav-a nav-b'><span class="nav-a-content">(.*?)</i,  //add
            merchantInfo:
              /class="a-size-base a-color-secondary a-nowrap"[\s\S]*?>([\s\S]*?)<\/div/i,
            title: /id="productTitle[\s\S]*?>([\s\S]*?)</i,
            fba: /(isAmazonFulfilled=1)/i,
            fba3: /( and sent from )/i,
            fba2: /class="tabular-buybox-text"[\s\S]*?<span class="a-size-small">[\s\S]*?<\/div>/gi,

            sponsored: /(Sponsored)/g,
            //date:/Date First Available.*?class="value">(.*?)</g,
            fbm: /(sold by)/i,
            //date1:/Date first available at Amazon.co.uk:<\/b>([\s\S]*?)</g,
            date: /Date First Available[\s\S]*?<td class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/i,
            date1: /Date first[\s\S]*?<span>([\s\S]*?)<\/span>/i,
            date2: /Date First Available[\s\S]*?<span>([\s\S]*?)</g,
            //date1:/Date First Available:[\s\S]*?<\/span>([\s\S]*?)</g,
            // amz: /(Dispatched from and sold by Amazon.)/i,
            amz: /(Sent from and sold by Amazon.)/i,
            parentAsin: /parentAsin":"(.*?)"/i,
            canonical: /rel="canonical" href="(.*?)"/i,
            canonicalShort: /http:.*?\/\/.*?\/(.*)\/dp/i,
            price1: /id="priceblock_[\s\S]*?\£([\d,.]*)(?:<| )/gi,
            price: /id="priceblock_ourprice"[\s\S]*?\£([\d,.]*)(?:<| )/gi,
            price2: /a-color-price'.*\£([\d,.]*)</i,
            price3:
              /id="olp_feature_div[\s\S]*?a-color-price[\s\S]*?>\£([\d,.]*)<\/span>/gi,
            price4:
              /class="a-price a-text-price a-size-medium apexPriceToPay"[\s\S]*?aria-hidden="true">([\s\S]*?)<\/span>/gi,
            price6: /a-offscreen.*?>.*?(\d*\.?\d+)/gi,

            //price2: /a-color-price'.*\$(.*?)</i,
            //price3: /offer-price.*?>\£([\d,.]*)</i,
            //reviews: /<span id="acrCustomerReviewText".*?>(.*?)customer/ig,
            weight:
              /(Pounds)|(Kilograms)|(kilogrammes)|(kilogramos)|(Grams)|(Kilogramm)|(Gramm)|(grammes)|(Ounces)|(Kg)|(grammi)|(gramos)/gi,
            is_adult:
              /(Erotic Massage Kits)|(Erotic Massagers & Vibrators)|(Bladder Control Devices)|(Appareils masturbateurs cup)|(Masseurs électriques portables)/,
            reviews: /acrCustomerReviewText.*?>([\d,]*) ratings/i,
            reviews1:
              /<span id="acrCustomerReviewText[\s\S].*?>(.*?)rating<\/span>/gi,
            //price3: /offer-price.*?>\$(.*?)</i,
            variationsJson:
              /displayTypeProperties[\s\S]*"dimensionValuesDisplayData" : ({.*?})/i,
            dimensionsJson: /dataToReturn[\s\S]*"dimensions":(\[.*?\])/i,
            imageHiRes:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"hiRes":"(.*?)"/i,
            imageLarge:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"large":"(.*?)"/i,
            imageThumb:
              /var data = {[\s\S]*?'colorImages':[\s\S]*?"thumb":"(.*?)"/i,

            variationsSwatchUnselectedAttributes:
              /swatchElement\ unselected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchUnselectedAsin:
              /swatchElement\ unselected.*[\s\S]*?\/dp\/(.*?)\//gi,
            variationsSwatchSelectedAttributes:
              /swatchElement\ selected.*[\s\S]*?<span>(.*?)<\/span>/gi,
            variationsSwatchSelectedAsin:
              /swatchElement\ selected.*[\s\S]*?\/offer-listing\/(.*?)\//gi,
          },
        },
      },
    },
  };

  function normalize(url, tld) {
    //拼接地址
    return (
      (amazonProfiles[tld].ssl ? "https://" : "http://") +
      amazonProfiles[tld].domain +
      toRelative(url)
    ); //判断网站是否为https还是http
  }

  function stripSchema(url) {
    return url.replace(/^((https?:)?\/\/)?/i, ""); //去掉https://
  }

  function toRelative(url) {
    return url.replace(/^((https?:)?\/\/)?[^\/]*\/?/i, "/"); //获取asin站点网址后面的具体链接
  }

  function getHostname(url) {
    url = stripSchema(url);

    if (url.indexOf("/") > 0) {
      //当URL中有斜杠时只取前面的字符串
      url = url.substr(0, url.indexOf("/"));
    }

    if (url.indexOf("?") > 0) {
      //当URL中有问号时只取前面的字符串
      url = url.substr(0, url.indexOf("?"));
    }

    return url;
  }

  function getTld(url) {
    return getHostname(url).split(".").pop(); //把字符串转化成数组，并返回最后一个元素
  }
  /**
   *
   */
  let Product = function (url, store) {
    return {
      get asin() {
        //获取asin
        // USRK-22: not pulling sponsored, because 'slredirect' is match
        // to the [a-z0-9]{10}
        // example:
        // https://www.amazon.com/gp/slredirect/picassoRedirect.html/ref=pa_sp_atf_beauty_sr_pg1_1?ie=UTF8&adId=A0861501SYXKLHPGR88V&url=https%3A%2F%2Fwww.amazon.com%2FLOccitane-Shea-Butter-Hand-Cream%2Fdp%2FB002U0KUTE%2Fref%3Dsr_1_1%3Fs%3Dbeauty%26ie%3DUTF8%26qid%3D1487170098%26sr%3D1-1-spons%26keywords%3DHand%2BCream%26psc%3D1&qualifier=1487170098&id=5348677164748551&widgetName=sp_atf
        url = url.replace(/slredirect/, "");
        let matches = url.match(/(\/|=|%2F)([a-z0-9]{10})(\/|\?|#|%2F|$)/i);

        return matches ? matches[2] : "";
      },
      get store() {
        return store; //当前站点
      },
      get url() {
        return normalize("/dp/" + this.asin, store.tld); //拼接asin的链接地址
      },
    };
  };

  let Search = function (url) {
    return {
      get supported() {
        return (
          url.match(/(\/s(\?|earch\/|\/))|(\/dp\/)/) ||
          url.indexOf("gp/bestsellers") != -1 ||
          url.match(/Best-Sellers/i) != -1
        ); //返回存在的/s/ /s? /search/ zohgn 存在哪些
      },
    };
  };

  let Unsupported = {
    get supported() {
      return false;
    },
  };

  let Amazon = function (url) {
    let tld = getTld(url); //得到当前站点（例如 com de）
    return {
      get currency() {
        if (!amazonProfiles[this.tld]) {
          //当前站点不存在则返回空
          return "";
        }

        return amazonProfiles[this.tld].currency; //获取当前站点的货币符号
      },
      get supported() {
        for (let i in amazonProfiles) {
          if (amazonProfiles[i].domain == this.hostname) {
            return amazonProfiles[i].supported; //检查是否支持站点
          }
        }

        return false;
      },
      get salesSupported() {
        return this.supported && amazonProfiles[this.tld].sales; //站点支持的时候sales的真假
      },
      get sslSupported() {
        return this.supported && amazonProfiles[this.tld].ssl; //站点支持的时候ssl的真假
      },
      get regex() {
        if (!amazonProfiles[this.tld]) {
          return {};
        }
        //返回该站点的正则
        return amazonProfiles[this.tld].regex;
      },
      get valid() {
        if (!amazonProfiles[this.tld]) {
          //站点不存在返回false
          return false;
        }
      },
      get hostname() {
        return getHostname(url); //当前站点网址
      },
      get search() {
        if (!this.supported) {
          return Unsupported;
        }
        //supported为true时URL存在的字符
        return Search(url); //判断是否为搜索结果页的url
      },
      get tld() {
        return tld; //返回站点
      },
      get url() {
        return normalize(url, this.tld); //获取asin的链接
      },
      parse: function (partial) {
        return Amazon(normalize(partial, this.tld)); //获取每个asin的信息
      },
      product: function (url) {
        return Product(normalize(url, this.tld), this);
      },
      URL: {
        production: "https://unicornsmasherpro.com/api/",
        developper: "https://beta.unicornsmasherpro.com/api/",
      },
      env: "production",// 正式环境
      // env: "developper",// 测试环境
      // dev: "developper",// 测试环境
    };
  };

  return Amazon;
})();

var regex_main = {
  //获取asin信息的正则
  search: {
    url: {
      domain: /:\/\/(.*?)\//i,
      keywords: /keywords=(.+?)(?:&|$)/i,
      page: /&page=[\d]*/i,
    },
  },
  product: {
    url: {
      domain: /:\/\/(.*?)\//i,
      asin: /\/dp\/(.+?)(?:\/|$)+/i,
      keywords: /keywords=(.+?)(?:&|$)/i,
      canonical: /:\/\/.*?\/(.*?)\//i,
    },
  },
};
