chrome.runtime.onMessage.addListener(
  function(request, sender, sendResponse) {
    if (request.action == "refreshSidebar") {
      dashboard.refreshFromStorage();
    }
  }
);
$(document).ready( function() {
  var table = $('#results-table').DataTable({//第三方插件DataTable
    "dom": 'lfrtpi',//定义DataTables的组件元素的显示和显示顺序
    "processing": false,//是否显示处理状态
    "ordering": true,
    "autoWidth": false,//控制Datatables是否自适应宽度
    "paging": false,//是否开启本地分页
    "searching": true,//是否允许Datatables开启本地搜索
    "info": false,//控制是否显示表格左下角的信息
    "rowId": "rank",//数据属性，Datatables在渲染的时候给 trTag设置的ID
    "columnDefs": [//设置定义列的初始属性
      { "visible": false, "targets": [ 3 ] },
      {
        "targets": [ 0 ],
        "class": "td-checkbox",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            return '<input type="checkbox" name="dig-checkbox" id="dig-checkbox"/><label for="dig-checkbox"></label>'
          }else{
          	return '<input type="checkbox" name="dig-checkbox" id="dig-checkbox"/><label for="dig-checkbox"></label>'
          }
        },
      },
      {
        "targets": [ 1 ],
        "class": "td-rank",
        "data": function (row, type, set, meta) {
          if (type === "display") {
          	var variation= JSON.stringify(row.variations);
            if (row.asins.length > 1) return "<span class='has-tooltip variations-switch' data-tooltip='Show/hide variations' data-variations = '"+variation+"'>+</span>" + row.rank;
            else return "<span class='has-tooltip variations-switch' data-tooltip='Show/hide variations' data-variations = '"+variation+"'>+</span>" + row.rank;
          }
          else {
            return row.rank;
          }
        },
      },
      {
        "targets": [ 2 ],
        "class": "td-title",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            return "<div class='ellipsis' title='" + row.title + "'><a href='" + row.url + "' target='_blank' data-image='" + row.image + "' onclick='this.stopPropagation()'>" + row.title + "</a></div>" +
//          "<div class='category-brand'>" + row.category + " / " + row.brand + "</div>" +
            "<div class='canonical'>" + row.canonicalShort + "</div>";
          }
          else {
            return row.title;
          }
        },
      },
      {
        "targets": [ 3 ],
        "class": "td-link",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            return "http://" + row.domain + "/" + row.canonicalShort + "/dp/" + row.asin;
          }
          else {
            return "http://" + row.domain + "/" + row.canonicalShort + "/dp/" + row.asin;
          }
        },
      },
      {
        "targets": [ 4 ],
        "class": "td-brand ellipsis",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            return "<span title='" + row.brand + "'>" + row.brand + "</span>";
          }
          else {
            return row.brand;
          }
        },
      },
      {
        "targets": [ 5 ],
        "class": "td-sellers",
        "data": function (row, type, set, meta) {
          if (type === "display") {
          	if(!row.sellersNew) row.sellersNew = '-';
          	if(!row.sellersUsed) row.sellersUsed = '-';
            return row.sellersNew + " / " + row.sellersUsed;
          }
          else {
            return row.sellersNew + row.sellersUsed;
          }
        },
      },
      {
        "targets": [ 6 ],
        "class": "td-variations",
        "data": function (row, type, set, meta) {
          if (type === "display") {
          	
            if (row.asins.length < 1) return "<span>1</span>";
            return "<span>"+row.asins.length+"</span>";
          }
          else {
            return row.asins.length;
          }
        },
      },
      {
        "targets": [ 7 ],
        "class": "td-price",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            if ($.isNumeric(row.price)) return '<span>'+amazon(row.domain).currency + row.price + '</span><a href="https://www.alibaba.com/trade/search?fsb=y&IndexArea=product_en&CatId=&SearchText='+$('#search-keywords').html()+'" target="_blank" class = "share-img has-tooltipPro" data-tooltipPro="Check similar product cost on Alibaba.com"></a>'
            return '-<a href="https://www.alibaba.com/trade/search?fsb=y&IndexArea=product_en&CatId=&SearchText='+$('#search-keywords').html()+'" target="_blank" class = "share-img has-tooltip" data-tooltip="Check similar product cost on Alibaba.com"></a>'
          }
          else {
            return row.price;
          }
        },
      },
      {
        "targets": [ 8 ],
        "class": "td-category ellipsis",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            return "<span title='" + row.category + "'>" + row.category + "</span>";
          }
          else {
            return row.category;
          }
        },
      },
      {
        "targets": [ 9 ],
        "class": "td-salesrank",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            return "<div class='salesrank-number'>" + helper.numberWithCommas(row.salesRank) + "</div>" +
            "<div class='asin'>" + row.asin + "</div>";
          }
          else {
            return row.salesRank;
          }
        },
      },
      {
        "targets": [ 10 ],
        "class": "td-sales",
        "data": function (row, type, set, meta) {
          if (!amazon(row.domain).salesSupported) {
            return '';
          }

          if (type === "display") {
            if (row.sales < 5) return "< 5";
            return helper.numberWithCommas(row.sales);
          }
          else {
            return row.sales;
          }
        },
      },
      {
        "targets": [ 11 ],
        "class": "td-revenue",
        "data": function (row, type, set, meta) {
          if (!amazon(row.domain).salesSupported) {
            return '';
          }

          if (type === "display") {
            if (row.sales < 5) return "< " + amazon(row.domain).currency + Math.round(helper.toNumber(row.price) * 5);
            if ($.isNumeric(row.revenue)) return amazon(row.domain).currency + helper.numberWithCommas(row.revenue);
            else return "-";
          }
          else {
            return row.revenue;
          }
        },
      },
      {
        "targets": [ 12 ],
        "class": "td-reviews",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            return "<a href='http://" + row.domain + "/product-reviews/" + row.asin +"' target='_blank'>" + row.reviews + "</a>";
          }
          else {
            return row.reviews;
          }
        },
      },
      {
        "targets": [ 13 ],
        "class": "td-rating",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            return row.rating;
          }
          else {
            return row.rating;
          }
        },
      },
      {
        "targets": [ 14 ],
        "class": "td-fba",
        "data": function (row, type, set, meta) {
          if (type === "display") {
            if (row.fba == "FBA") return "<span class='has-tooltip' data-tooltip='Fulfilled by Amazon'>" + row.fba + "</span>";
            if (row.fba == "AMZ") return "<span class='has-tooltip' data-tooltip='Fulfilled and sold by Amazon'>" + row.fba + "</span>";

            return row.fba;
          }
          else {
            return row.fba;
          }
        },
      },
      {
        "targets": [ 15 ],
        "class": "td-list",
        "data": function (row, type, set, meta) {
          if (type === "display") {
          	if(row.date) return '<div class="has-tooltip" data-tooltip="Date first listed on Amazon">' + row.date + '</div>';
            return '<div class="has-tooltip" data-tooltip="Date first listed on Amazon">---</div>';
          }
          else {
            return '-';
          }
        },
      }
    ]
  });


  var dashboard = new Dashboard(table);

    $('#results-table').on('draw.dt', function () {//表格完成绘制事件
    dashboard.bindTableEvents();//绑定事件
  });

  $('#float-head thead th').click(function() {
    var headerClass = $(this).attr("class");
    $('#results-table th.' + headerClass).trigger("click");//触发点击事件
  });

  $('#search-box').on('keyup', function() {//实时搜索
    dashboard.filterHistory($(this).val())
  });

  $('#search-box-favorite').click(function() {//收藏
    $(this).toggleClass('fav');
    dashboard.filterHistory($('#search-box').val());
  });

  $('.btn-expand').click(function() {
    $('#tooltip').offset({ top: "-9999", left: "-9999" } );

    if ($('#sidebar').css("left") == "-216px") {
      $('#footer .btn-expand').hide();
      $('.btn-expand').html('&#10094;');
      $('#sidebar').css("left", "0");
      $('#main').css("margin-left", "216px");
    }
    else {
      $('#footer .btn-expand').show();
      $('.btn-expand').html('&#10095;');
      $('#sidebar').css("left", "-216px");
      $('#main').css("margin-left", "0");
    }

    dashboard.resize();
  });

  $('#btn-csv').click(function() {
    dashboard.toCSV();
  });

  $('#btn-image').click(function() {
    $('.image-hidden').hide();
  });

  $('#btn-filter').click(function() {//展示筛选
    $('#filter').slideToggle(400).toggleClass("fadingOut");
  });

  $('#filter #btn-clear-filters').click(function() {//清空筛选条件
    $('#filter input[name^=filter]').val('');
    $('#filter input[name=filter-fba]').prop('checked', false);
    $('#results-table tr').show();
  });

  $('#filter input').on('change', function() {//确认筛选
    dashboard.filterTable();
  });

  $('#btn-next-page').click(function() {//下一页
    if (typeof dashboard.activeHistory != "undefined") {
      dashboard.updateFooterButtons(0);
      dashboard.activeHistory.scrapeProducts();
      dashboard.renderHistorySidebar();
    }
  });

  $('#search-favorite').click(function() {
    dashboard.toggleFavorite(dashboard.activeHistoryIndex);
  });

  $('#btn-clear-history').click(function() {//展示或者隐藏按钮
    $('#sidebar-footer').toggle();
    $('#clear-history-menu').toggle();
  });

  $('#btn-clear-history-cancel').click(function() {//展示或者隐藏按钮
    $('#sidebar-footer').show();
    $('#clear-history-menu').hide();
  });

  $('#btn-clear-history-all').click(function() {
    if ($(this).html() == "Clear All") {//确认
      $(this).html('Sure?').addClass('btn-danger');
      return;
    }

    $.each(dashboard.history, function(index, data) {//删除这个关键词的数据
      dashboard.removeHistory(index);
    });

    $(this).html('Clear All').removeClass('btn-danger');
    $('#sidebar-footer').show();
    $('#clear-history-menu').hide();
  })
  .on('mouseout', function() {
    $(this).html('Clear All').removeClass('btn-danger');
  });

  $('#btn-clear-history-keep-favorites').click(function() {//收藏
    if ($(this).html() == "Keep Favorites") {//确认收藏
      $(this).html('Sure?').addClass('btn-danger');
      return;
    }

    $.each(dashboard.history, function(index, data) {
      if (!data.favorite) dashboard.removeHistory(index);
    });

    $(this).html('Keep Favorites').removeClass('btn-danger');
    $('#sidebar-footer').show();
    $('#clear-history-menu').hide();
  });

  $('#btn-image').click(function() {//打开数据生成的图片
    window.open(helper.extUrl() + "/toimage.html?history=" + dashboard.activeHistoryIndex, '_blank');
  });

  $('#search-list').height($(document).height() - 225);
  dashboard.resize();
  $(window).resize(function() {
	    dashboard.resize();
	});
});




/**
 * Dashboard
 */

var Dashboard = function(table) {
  this.table = table;
  this.history = {};
  this.activeHistoryIndex = "";
  this.refreshFromStorage();
  this.resize();
};



Dashboard.prototype.refreshFromStorage = function() {//获取本地储存数据

  var self = this;
  this.history = {};

  chrome.storage.local.get(null, function(result) {//获得数据
    var firstHistoryIndex = "";//历史记录第一条
    $.each(result, function(index, search) {
      if (index.substring(0, 9) == "_history " && search.url) {//给history添加数据
        self.history[index] = new UnicornSearch(search.url);//抓取的数据及方法赋值给self.history[index]
        self.history[index].set(search);//调用UnicornSearch对象中的set方法并传入search参数
        self.history[index].save = 1;//设置self.history[index]的save属性值为1
        self.history[index].ajaxCompleteCallback = ajaxComplete(self);
        if (firstHistoryIndex == "") firstHistoryIndex = index;//把第一个历史记录赋值
      }
    });
    if ((self.activeHistoryIndex == "") && (firstHistoryIndex != "")) {
      self.activeHistoryIndex = firstHistoryIndex;
      self.showHistory(self.activeHistoryIndex);//展示活动历史记录的相关数据
    }
    self.renderHistorySidebar();//刷新历史条

  });
};


Dashboard.prototype.renderHistorySidebar = function() {//刷新历史条

  var self = this;
  var searchList = "";

  historySorted = Object.keys(this.history).sort(function(a,b) {//Object.keys方法获取key值
    return self.history[b].timestamp - self.history[a].timestamp//对history的进行排序 以时间戳,
  });

  $.each(historySorted, function(index, historyIndex) {//循环得到HTML字符串并插入数据
    var search = self.history[historyIndex];

    if (self.activeHistoryIndex == "_history " + search.domain + " " + search.keywords) var div = "<div class='history active' data-index='" + historyIndex + "'>";//如果是第一条历史记录，则设置为活动条
    else var div = "<div class='history' data-index='" + historyIndex + "'>";//如果不是则设为普通历史记录

    div += "<div class='favorite";
    if (search.favorite == 1) div += " fav";//如果是收藏了关键词
    div += "'>&#9733;</div>";
    div += "<div class='keywords'>" + helper.decodeURI(search.keywords) + "</div>";

    if (search.activeAjaxCalls == 0) div += "<div class='search-date'>" + helper.timestampToDate(search.timestamp) + "</div>";
    else div += "<div class='search-date' style='visibility: visible;'>Analyzing...</div>";

    div += "<div class='remove-history'>&#x2715;</div>";
    div += "<a href='http://" + search.domain + "/s/keywords=" + search.keywords + "' class='open-search' target='_blank'>&#8599;</a>";

    div += "</div>";

    searchList += div;
  });

  $('#search-list').html(searchList);//插入页面

  $('.history .remove-history').unbind('click').click(function(e) {//删除当前关键词的数据
    if ($(this).html() != "Delete?") $(this).html('Delete?');
    else {
      e.preventDefault();
      self.removeHistory($(this).parent().data('index'));
    }
  })
  .unbind('mouseout').on('mouseout', function() {
    $(this).html('&#x2715;');
  });

  $('.history').unbind('click').click(function() {//切换当前的关键词 并切换表格显示的数据
    $('.history').removeClass('active');
    $(this).addClass('active');

    self.showHistory($(this).data('index'));//展示当前点击的关键词的数据
  });


  $('.history .favorite').unbind('click').click(function() {
    self.toggleFavorite($(this).parent().data('index'));
  });

};


Dashboard.prototype.resize = function() {//设置尺寸
	$('#float-head .td-checkbox').width($('#results-table thead .td-checkbox').width());
  $('#float-head .td-rank').width($('#results-table thead .td-rank').width());
  $('#float-head .td-title').width($('#results-table thead .td-title').width());
  $('#float-head .td-brand').width($('#results-table thead .td-brand').width());
  $('#float-head .td-sellers').width($('#results-table thead .td-sellers').width());
  $('#float-head .td-variations').width($('#results-table thead .td-variations').width());
  $('#float-head .td-price').width($('#results-table thead .td-price').width());
  $('#float-head .td-category').width($('#results-table thead .td-category').width());
  $('#float-head .td-salesrank').width($('#results-table thead .td-salesrank').width());
  $('#float-head .td-sales').width($('#results-table thead .td-sales').width());
  $('#float-head .td-revenue').width($('#results-table thead .td-revenue').width());
  $('#float-head .td-reviews').width($('#results-table thead .td-reviews').width());
  $('#float-head .td-rating').width($('#results-table thead .td-rating').width());
  $('#float-head .td-fba').width($('#results-table thead .td-fba').width());
	$('#float-head .td-list').width($('#results-table thead .td-list').width());
  $('#float-head thead,#float-head tfoot').width($('#main').width());
//$('#results-table,#results-table thead,#results-table tbody').width($('#main').width());
  $('#footer').width($('#main').width());
  $('#header').width($('#main').width());

  this.updateFooterButtons();

};


Dashboard.prototype.updateFooterButtons = function(forceShow) {//更新底部

  var show = 1;
  if (typeof this.activeHistory == "undefined") show = 0;
  else if (this.activeHistory.activeAjaxCalls > 0) show = 0;

  if (typeof forceShow !== "undefined") show = forceShow;

  if (show) {//判断是否展示这几个按钮
    $('#btn-csv').show();
    $('#btn-next-page').show();
    $('#btn-filter').show();
    $('#btn-image').show();
  }
  else {
    $('#btn-csv').hide();
    $('#btn-next-page').hide();
    $('#btn-filter').hide();
    $('#btn-image').hide();
  }
};


Dashboard.prototype.toggleFavorite = function(index) {//保存收藏状态

  var self = this;
  this.history[index].favorite = 1 - this.history[index].favorite;

  chrome.runtime.sendMessage({ action: "saveSearch", search: self.history[index] }, function(response) {
  });

  if (this.history[index].favorite) $("div[data-index='" + index + "'] .favorite").addClass('fav');
  else $("div[data-index='" + index +"'] .favorite").removeClass('fav');
};


Dashboard.prototype.filterHistory = (function(filter) {//获取筛选历史

  var self = this.dashboard;
  var favorite = 0;
  if ($('#search-box-favorite').hasClass('fav')) favorite = 1;

  filter = filter.toLowerCase();//小写

  $.each($('#sidebar .history'), function(index, historyDiv) {

    var show = 0;

    var index = $(historyDiv).data('index');
    var search = self.history[index];

    if (helper.decodeURI(search.keywords).toLowerCase().indexOf(filter) > -1) show = 1;

    $.each(search.products, function(index, product) {
      if (product.title.toLowerCase().indexOf(filter) > -1) show = 1;
    });

    if ((favorite) && (search.favorite == 0)) show = 0;

    if (show) $(historyDiv).show();
    else $(historyDiv).hide();
  });

}).bind(this);


Dashboard.prototype.showHistory = function(index) {//展示历史记录
  var dashboard = this;

  if (typeof index == "undefined") {//传的值不存在
    if (!$('#search-list .history.active').length) return;//没有选中的关键词

    index = $('#search-list .history.active').data('index');//从选中的关键词标签获取数据
  }

  if (typeof this.history[index] == "undefined") {//存储的值中没有这个关键词数据
    $('#search-keywords').html('');//清空table的当前关键词
    $('#search-status').html('');//清空数据获取的时间
    this.table.clear().draw();//清空表格数据
    return;
  }

  $('#main').data('index', index);//获取数据
  $('#search-favorite').data('index', index);//获取数据
  $('#search-keywords').html(helper.decodeURI(this.history[index].keywords));//获取关键词
//没有请求事，显示数据刷新
  if (!this.history[index].activeAjaxCalls) $('#search-status').html("Last Updated: " + helper.timestampToDate(this.history[index].timestamp) + " (<span id='refresh-search' style='color: #6981FF;'>Refresh</span>)");
  else $('#search-status').html("Analyzing...");//显示加载中
  
  $('#refresh-search').unbind('click').click(function() {
    dashboard.activeHistory.products = dashboard.activeHistory.newProductsCollection();
    dashboard.activeHistory.multiPage = dashboard.activeHistory.newProductsCollection();
    dashboard.activeHistory.pageNext = 1;
    dashboard.activeHistory.scrapeProducts();
    dashboard.activeHistory.multiProducts();
    dashboard.showHistory();
  });

  this.activeHistory = index;
  if (this.activeHistory.favorite) $('#search-favorite').addClass('fav');//是否被收藏了
  else $('#search-favorite').removeClass('fav');
  
  this.table.clear();//清除之前的数据展示
  if(this.activeHistory.products.length > 0) this.table.rows.add(this.activeHistory.products).draw();//插入数据
  else this.table.rows.add(this.activeHistory.multiPage).draw();//插入数据


  $.each(this.activeHistory.products, function(index, product) {
    if (product.open == 1) {
      $('#' + product.rank + ' .td-rank').trigger('click');//触发点击事件
    }
  });

  this.updateFooter();
  this.resize();
};


Dashboard.prototype.updateFooter = function() {//表格尾部
  var rows = $('table#results-table>tbody>tr:visible');
  var tfoot = [];
  var priceTotal = 0;
  var rankTotal = 0;
  var salesTotal = 0;
  var revenueTotal = 0;
  var reviewsTotal = 0;
  var ratingTotal = 0;
  var variationsTotal = 0;

  var categoryList = {};
  var finalCategoryCount = 0;
  var finalCategory = "";

  $.each(rows, function(index, row) {//获取数据
    if (typeof $(row).attr('id') != "undefined") {
      if($(row).find('.td-price span').html()) priceTotal += helper.toNumber($(row).find('.td-price span').html().replace('$', ''));
      rankTotal += helper.toNumber($(row).find('.td-salesrank .salesrank-number').html());
      salesTotal += helper.toNumber($(row).find('.td-sales').html());
      revenueTotal += helper.toNumber($(row).find('.td-revenue').html().replace('$', ''));
      reviewsTotal += helper.toNumber($(row).find('.td-reviews a').html());
      ratingTotal += helper.toNumber($(row).find('.td-rating').html());
      variationsTotal += helper.toNumber($(row).find('.td-variations span').html());

      category = $(row).find('.td-category').html();
      categoryList[category] = categoryList[category] ? categoryList[category] + 1 : 1;
    }
  });

  $.each(categoryList, function(category, categoryCount) {//出现的类 和出现的次数
    if (categoryCount > finalCategoryCount) {
      finalCategory = category;
      finalCategoryCount = categoryCount;
    }
  });

  if (rows.length > 0) {//计算
    tfoot.count = rows.length;
    tfoot.price = parseFloat(priceTotal/rows.length).toFixed(2);
    tfoot.rank = helper.numberWithCommas(parseFloat(rankTotal/rows.length).toFixed(0));
    tfoot.sales = helper.numberWithCommas(parseFloat(salesTotal/rows.length).toFixed(0));
    tfoot.revenue = helper.numberWithCommas(parseFloat(revenueTotal/rows.length).toFixed(0));
    tfoot.reviews = helper.numberWithCommas(parseFloat(reviewsTotal/rows.length).toFixed(0));
    tfoot.variations = helper.numberWithCommas(parseFloat(variationsTotal/rows.length).toFixed(0));
    tfoot.rating = parseFloat(ratingTotal/rows.length).toFixed(1);
  }
  else {
    tfoot.price = "";
    tfoot.rank = "";
    tfoot.sales = "";
    tfoot.revenue = "";
    tfoot.reviews = "";
    tfoot.variations = "";
    tfoot.rating = "";
  }

  tfoot.category = finalCategory;
//更新
  $('#float-head tfoot .td-rank').html(tfoot.count);
  $('#float-head tfoot .td-price').html('$' + tfoot.price);
  $('#float-head tfoot .td-salesrank').html(tfoot.rank);
  $('#float-head tfoot .td-sales').html(tfoot.sales);
  $('#float-head tfoot .td-revenue').html('$' + tfoot.revenue);
  $('#float-head tfoot .td-reviews').html(tfoot.reviews);
  $('#float-head tfoot .td-rating').html(tfoot.rating);
  $('#float-head tfoot .td-category').html(tfoot.category);
  $('#float-head tfoot .td-variations').html(tfoot.variations);

};


Dashboard.prototype.toCSV = function() {

  var csv = "'Rank," +//配置表头
    "Title," +
    "Canoncial," +
    "Link," +
    "Brand," +
    "Category," +
    "New Sellers," +
    "Used Sellers," +
    "Variations," +
    "Price," +
    "Sales Rank," +
    "Sales/month," +
    "Revenue/month," +
    "Reviews," +
    "Rating," +
    "FBA\r\n";
    var filters = {};
    var sFilters = {};
    if (localStorage.setFilters != undefined) {//收集数据
        filters = JSON.parse(localStorage.setFilters);
        filters.salesRank = filters.salesrank;
        delete filters.salesrank;
        delete filters.hideSponsored;
        sFilters.fba = filters.onlyFba;
        delete filters.onlyFba;
        sFilters.sellersNew = filters.sellers.min;
        sFilters.sellersUsed = filters.sellers.max;
        delete filters.sellers;
    }


    this.table.rows().every( function ( rowIdx, tableLoop, rowLoop ) {//配置数据
      var data = this.data();
      var trData= $('#results-table .td-checkbox input');
        var filtred = true;
        if (filters != "" || sFilters != ""){
            if (sFilters.fba == 1 && data['fba'] == "-") filtred = false;
            if (sFilters.sellersNew != "" && data.sellersNew < sFilters.sellersNew) filtred = false;
            if (sFilters.sellersUsed != "" && data.sellersUsed.replace('-','') < sFilters.sellersUsed) filtred = false;
            if (filters != "") {
                for (var f in filters) {
                    if (filters[f].min != "" && data[f].toString().replace(',','').replace('-','') < filters[f].min) filtred = false;
                    if (filters[f].max != "" && data[f].toString().replace(',','').replace('-','') > filters[f].max) filtred = false;
                }
            }
						
        }
        if(trData.is(':checked')){
        	if(!trData.eq(rowIdx).is(':checked')){
        		filtred = false;
        	}
        }
        if (filtred) {
            csv += '"' + data.rank + '",';
            csv += '"' + data.title + '",';
            csv += '"' + data.canonicalShort + '",';
            csv += '"' + data.canonical + '",';
            csv += '"' + data.brand.replace('&amp;', '&') + '",';
            csv += '"' + data.category.replace('&amp;', '&') + '",';
            csv += '"' + data.sellersNew + '",';
            csv += '"' + data.sellersUsed + '",';
            csv += '"' + data.asins.length + '",';
            csv += '"' + data.price + '",';
            csv += '"' + data.salesRank + '",';
            csv += '"' + data.sales + '",';
            csv += '"' + data.revenue + '",';
            csv += '"' + data.reviews + '",';
            csv += '"' + data.rating + '",';
            csv += '"' + data.fba + '"';
            csv += '"' + data.date + '"\r\n';
        }

  });

  var location = 'data:application/csv;charset=UTF-8,' + encodeURIComponent(csv);//设置编码

  var filename = $('#main').data('index') + ".csv";//设置文件格式


  var pom = document.createElement('a');//导出按钮
    pom.setAttribute('href', location);
    pom.setAttribute('download', filename);
//触发导出
    if (document.createEvent) {
        var event = document.createEvent('MouseEvents');
        event.initEvent('click', true, true);
        pom.dispatchEvent(event);
    }
    else {
        pom.click();
    }

};


Dashboard.prototype.bindTableEvents = function() {//绑定表格事件
  var self = this;
  $('#results-table tbody .td-title')//鼠标进入title时展示图片
  .unbind('mouseover')
  .unbind('mouseout')
  .on('mouseover', function() {
    $('#product-details img').prop('src', $(this).find('a').data('image'));
    $('#product-details').show();
  })
  .on('mouseout', function() {
    $('#product-details').hide();
  });

  $('table#results-table>tbody>tr>td .variations-switch').unbind('click').on('click', function() {
  	var pro = new UnicornProduct(self.activeHistory.url)
		var tr = $(this).closest('tr'),index = $(tr).attr('id')-1,variations = $(this).data('variations');
		var variationStr = JSON.stringify(variations)
		if($(this).hasClass('swithes')) {$(".index-"+index).hide();$(this).removeClass('swithes');$(tr).next('.analyse').remove();$(tr).next('.no-analyse').remove()}
		else {
			$(this).addClass('swithes');
			if(variationStr != "{}") {
				$(".index-"+index).show();pro.getVariationDetails(index,variations,$(tr));
				$(".index-"+index).children('.td-sellers').show();
				$(".index-"+index).children('.td-variations').show();
				if($(".index-"+index).length>0) {$(tr).next('.analyse').remove();}
        else {$(tr).after('<tr class="analyse"><td colspan="13" style="text-align: center;font-size:14px;font-weight: 600;">Analyzing...</td></tr>');}
			}else {
				if($('.no-analyse').length <= 0){$(tr).after('<tr class="no-analyse"><td colspan="13" style="text-align: center;font-size:14px;font-weight: 600;">There are no additional variations for this product.</td></tr>')};}
			
		};
//  var tr = $(this).closest('tr');//找到当前td的tr
//      var row = self.table.row( tr );//在table中找到tr
//      if ( row.child.isShown() ) {//如果打开
//          // This row is already open - close it
//          row.child.hide();
//          tr.removeClass('shown');
//          tr.find('.td-rank span').html('&#9658;');
//          $('#tooltip').offset({ top: "-9999", left: "-9999" } );
//          row.data().open = 0;
//      }
//      else {
//          // Open this row
//
////          row.data().getVariationDetails();
//          row.data().open = 1;
//
//          var variationsTable = self.variationsTable(row.data());
//          row.child(variationsTable.div).show();//չʾ
//          tr.addClass('shown');
//          tr.find('.td-rank span').html('&#9660;');
//        $('#tooltip').offset({ top: "-9999", left: "-9999" } );
//
//
//          tr.next('tr').find('td').css("padding", "0");
//          tr.next('tr').find('.variations-table').DataTable({//设置表格
//          "dom": 'lfrtpi',
//          "processing": false,
//          "autoWidth": false,
//          "paging": false,
//          "searching": false,
//          "info": false,
//      "language": {
//              "zeroRecords": "There are no additional variations for this product."
//        },
//          "rowId": "asin",
//          "columnDefs": variationsTable.columnDefs,
//        })
//    .rows.add(variationsTable.variations).draw();
//
//      }
    });

  $('.has-tooltip').unbind('mouseenter mouseleave').hover(function() {//提示
    showTooltip($(this));
  }, function() {
    $('#tooltip').offset({ top: "-9999", left: "-9999" } );
  });
};


Dashboard.prototype.filterTable = function() {

  var self = this;
  var filters = this.activeHistory.filters;//获取以前的筛选条件

  var rows = $('table#results-table>tbody>tr');
  var showCount = 0;

  $.each(rows, function(index, row) {

    var show = 1;

    if ($('#filter input[name=filter-fba]').is(':checked')) {
      if ($(row).find('.td-fba').html() == "-") {//当选项没有值时
        show = 0;
      }
      filters.onlyFba = 1;
    }
    else filters.onlyFba = 0;
//判断是否显示这个tr
    show = show & self.filterInput('price', row)
          & self.filterInput('sellers', row)
          & self.filterInput('variations', row)
          & self.filterInput('salesrank', row)
          & self.filterInput('sales', row)
          & self.filterInput('revenue', row)
          & self.filterInput('reviews', row)
          & self.filterInput('rating', row)


    if (show) {
      $(row).show();//显示
      showCount++;//显示数加一
    }
    else {
      $(row).hide();//隐藏
    }

  });
    localStorage.setItem('setFilters', JSON.stringify(filters));
  this.updateFooter();
};


Dashboard.prototype.filterInput = function(name, row) {

  var show = 1;

  var minMax = { 'min': '', 'max': ''};

  if (name == "sellers") {//当那么是sellers
    var sellerCount = helper.toNumber( helper.regex( /(\d+)\b/i, $(row).find('.td-' + name).html() ) );

    if ($.isNumeric($('#filter input[name=filter-' + name + '-min]').val())) {//当前值小于最小值
      if (sellerCount < helper.toNumber($('#filter input[name=filter-' + name + '-min]').val())) show=0;
      minMax.min = helper.toNumber($('#filter input[name=filter-' + name + '-min]').val());
    }

    if ($.isNumeric($('#filter input[name=filter-' + name + '-max]').val())) {//当前值大于最大值
      if (sellerCount > helper.toNumber($('#filter input[name=filter-' + name + '-max]').val())) show=0;
      minMax.max = helper.toNumber($('#filter input[name=filter-' + name + '-max]').val());
    }

  }
  else if (name == "reviews") {
    var reviewsCount = helper.toNumber($(row).find('.td-' + name + ' a').html()  );

    if ($.isNumeric($('#filter input[name=filter-' + name + '-min]').val())) {//当前值小于最小值
      if (reviewsCount < helper.toNumber($('#filter input[name=filter-' + name + '-min]').val())) show=0;
      minMax.min = helper.toNumber($('#filter input[name=filter-' + name + '-min]').val());
    }

    if ($.isNumeric($('#filter input[name=filter-' + name + '-max]').val())) {//当前值大于最大值
      if (reviewsCount > helper.toNumber($('#filter input[name=filter-' + name + '-max]').val())) show=0;
      minMax.max = helper.toNumber($('#filter input[name=filter-' + name + '-max]').val());
    }

  }
  else if (name == "salesrank") {
    var reviewsCount = helper.toNumber( $(row).find('.td-' + name + ' .salesrank-number').html() );

    if ($.isNumeric($('#filter input[name=filter-' + name + '-min]').val())) {//当前值小于最小值
      if (reviewsCount < helper.toNumber($('#filter input[name=filter-' + name + '-min]').val())) show=0;
      minMax.min = helper.toNumber($('#filter input[name=filter-' + name + '-min]').val());
    }

    if ($.isNumeric($('#filter input[name=filter-' + name + '-max]').val())) {//当前值大于最大值
      if (reviewsCount > helper.toNumber($('#filter input[name=filter-' + name + '-max]').val())) show=0;
      minMax.max = helper.toNumber($('#filter input[name=filter-' + name + '-max]').val());
    }

  }
  else {

    if ($.isNumeric($('#filter input[name=filter-' + name + '-min]').val())) {//当前值小于最小值
      if (helper.toNumber($(row).find('.td-' + name).html()) < helper.toNumber($('#filter input[name=filter-' + name + '-min]').val())) show=0;
      minMax.min = helper.toNumber($('#filter input[name=filter-' + name + '-min]').val());
    }

    if ($.isNumeric($('#filter input[name=filter-' + name + '-max]').val())) {//当前值大于最大值
      if (helper.toNumber($(row).find('.td-' + name).html()) > helper.toNumber($('#filter input[name=filter-' + name + '-max]').val())) show=0;
      minMax.max = helper.toNumber($('#filter input[name=filter-' + name + '-max]').val());
    }
  }

  this.activeHistory.filters[name] = minMax;

  return show;
};


Dashboard.prototype.removeHistory = function(index) {//删除记录

  var self = this;
  if (this.activeHistoryIndex == index) this.activeHistoryIndex = "";


  chrome.runtime.sendMessage({ action: "removeSearch", search: this.history[index] }, function(response) {
    self.refreshFromStorage();
  });

  delete this.history[index];
};


Dashboard.prototype.variationsTable = function(product) {

  // Count dimensions

  var attributeDimensions = 1;

  if (typeof product.variations[Object.keys(product.variations)[0]] !== "undefined") {
    $.each(product.variations[Object.keys(product.variations)[0]], function(index, attribute) {
      if ($.isNumeric(index)) attributeDimensions++;
    });

    if (attributeDimensions > 1) attributeDimensions--;
  }


  // Create variations table

  // Create column definitions

  var columnDefs = [
    {
      targets: 0,
      title: "",
      class: "td-rank",
      data: function (row, type, set, meta) {
        return "";
      },
    },
    {
      targets: 1,
      title: "Variation",
      class: "td-title",
      data: function (row, type, set, meta) {
        if (type === "display") {
          return "<a href='https://" + row.domain + "/dp/" + row.asin + "' target='_blank' data-image='" + row.image + "' target='_blank'>" + row.asin + "</a>";
        }
        else {
          return row.asin;
        }
      },
    }
  ];


  // Column definition for attributes

//for (var i = 0; i < attributeDimensions; i++) {
//  if (typeof product.dimensions[i] !== "undefined") {//给创建的展开行添加数据
//    columnDefs.push({
//      targets: i + 2,
//      title: product.dimensions[i].replace(/_/ig, ' '),
//      data: "attribute" + i
//    });
//  }
//  else {
//    columnDefs.push({
//      targets: i + 2,
//      title: "Attribute " + i,
//      data: "attribute" + i
//    });
//  }
//}


  // Add price and rank columns at the end
	columnDefs.push({
    targets: attributeDimensions + 2,
    title: "Price",
    class: "td-price",
    data: "price",
  });
  
  columnDefs.push({
    targets: attributeDimensions + 2,
    title: "Category",
    class: "td-category",
    data: "price",
  });

  columnDefs.push({
    targets: attributeDimensions + 3,
    title: "Rank",
    class: "td-salesrank",
    data: "rank",
  });

  columnDefs.push({
    targets: attributeDimensions + 4,
    title: "Sales",
    class: "td-sales",
    data: function (row, type, set, meta) {
      return "";
    }
  });

  columnDefs.push({
    targets: attributeDimensions + 5,
    title: "Revenue",
    class: "td-revenue",
    data: "fba"
  });

  // Format variations data

  var variations = [];

  $.each(product.variations, function(index, variation) {

    var v = {};

    v.asin = index;
    v.domain = product.domain;
    v.price = variation.price;
    v.rank = variation.salesRank;
    v.image = variation.image;
    v.fba = variation.fba;

    $.each(variation, function(index, attribute) {
      if ($.isNumeric(index)) v["attribute" + index] = attribute;
    });

    variations.push(v);

  });


  // Variations table format

  var div = "<table class='variations-table'></table>";


  return {
    div: div,
    columnDefs: columnDefs,
    variations: variations
  };

};


Object.defineProperties(Dashboard.prototype, {
  activeHistory : {
    get: function() {
      return this.history[this.activeHistoryIndex];
    },
    set: function(index) {
      this.activeHistoryIndex = index;
    }
  },
});


function ajaxComplete(dashboard) {
  return function(index) {
    dashboard.updateFooterButtons();
    dashboard.renderHistorySidebar();
    if (dashboard.history[index].activeAjaxCalls == 0) {
      dashboard.history[index].storeResults();

      if (dashboard.activeHistoryIndex == index) dashboard.showHistory();
    }
  };
}


function showTooltip(el) {//提示

  var top = el.offset().top;
  var left = el.offset().left;
  var tooltip = el.data('tooltip');

  $('#tooltip').html(tooltip);

  var width = $('#tooltip').width();
  var height = $('#tooltip').height();

  if (left + width > $('body').width() - 17) left = $('body').width() - width - 17;
  top = top - height - 15;

  $('#tooltip').offset({ top: top, left: left }).html(tooltip).show();
}
