// https://www.amazon.com/product-reviews/undefined/ref=cm_cr_getr_d_paging_btm_1?ie=UTF8&sortBy=recent&pageNumber=1&pageSize=20&_=1635297901427
var helper = {
  isregex: function (regex, string) {
    if (!regex) {
      return ""
    }
    // console.log(string)
    // console.log(regex, 'product.category')
    var match = regex.exec(string);
    // console.log(match)
    if (match) return match[0];
    return "";
  },

  // Returns first match in regex; or ""
  regex: function (regex, string) {
    if (!regex) {
      return ""
    }
    regex.lastIndex = 0;
    var match = regex.exec(string);
    if (match) return match[1];
    return "";
  },
  regexs: function (regex, string) {
    if (!regex) {
      return ""
    }
    regex.lastIndex = 0;
    var match = regex.exec(string);
    if (match) return match[1];
    return "";
  },
  appendChild: (string) => {
    var div = document.createElement('div');
    div.innerHTML = string;
    return div
    // var span = div.childNodes[0];
    // var body = document.getElementsByTagName('body')[0];
    // body.appendChild(span);
  },

  // Returns all matches in a regex;
  regexAll: function (regex, string) {
    regex.lastIndex = 0;
    var matches = [];
    while (match = regex.exec(string)) {
      matches.push(match[1]);
    }
    return matches;
  },


  normaliseUrl: function (url, domain) {//拼接url
    return this.toHttps(domain + this.toRelative(url));
  },


  // Used to filter array to unique values only
  // filtered = array.filter( onlyUnique )
  onlyUnique: function (value, index, self) {
    return self.indexOf(value) === index;
  },


  // Returns Chrome Extension base URL
  extUrl: function () {
    return chrome.runtime.getURL("");
  },
  //格式化金额
  formatCurrency: function (n) {
    var re = /\d{1,3}(?=(\d{3})+$)/g;
    var n1 = n.replace(/^(\d+)((\.\d+)?)$/, function (s, s1, s2) { return s1.replace(re, "$&,") + s2; });
    return n1;
  },

  // Returns decoded URI string
  decodeURI: function (string) {
    return decodeURIComponent(string.replace(/\+/g, " "));//把加号转成空格,并解码
  },


  // Converts string to js number format
  toNumber: function (x) {
    // if(x === undefined) return 0;
    if (x.indexOf("$") > -1) x = x.replace(/\$/g, '');
    if (x.indexOf(",") > -1) x = x.replace(/,/g, '');
    if (x.indexOf("£") > -1) x = x.replace(/£/g, '');
    if (x.indexOf("€") > -1) x = x.replace(/€/g, '');
    if ($.isNumeric(x)) return Number(x);
    return 0;
  },


  //replace , to . for de,fr,es,it
  replaceDot: function (x) {
    x = x.replace(/,/g, '.');
    return x;
  },


  replacePoint: function (x) {
    if (!x) return x;
    x = x.replace(/\./g, ',');//替换符号
    return x;
  },
  replaceBlank: function (x) {
    if (!x) return x;
    x = x.replace(/\&nbsp;/g, ',');//替换符号
    return x;
  },

  replaceSpot: function (x) {
    if (!x) return x;
    x = x.replace(/\./g, '');//替换符号
    return x;
  },

  isNum: function (x) {
    var reg = /^(\d+.,?)+$/;
    return reg.test(x);
  },
  //去掉千位符
  delCommafy: function (num) {
    if (num != undefined) {
      num = num.toString();
      num = num.replace(/[ ]/g, ""); //去除空格  
      num = num.replace(/,/gi, '');
      return Number(num);
    }
  },

  trimStr: function (str) {//去掉两端空格
    return str.replace(/(^\s*)|(\s*$)/g, "");
  },


  clearHTMLComments: function (html) {//清除注释
    return html.replace(/<!--[\s\S]*?-->/g, '');
  },

  isCaptchaPage: function (html) {//判断页面
    if (html.match(/>Robot Check<\/title>/)) {
      return true;
    }
    return false;
  },

  // Adds comma thousands separator
  numberWithCommas: function (x) {
    if (!$.isNumeric(x)) return x;
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
  },
  // Returns count of active ajax calls
  ajaxCount: function () {
    return $.xhrPool.length;
  },


  // Returns date/time from timestamp
  timestampToDate: function (timestamp) {
    var d = new Date(timestamp);
    return d.toLocaleString();
  },


  // Array to Object
  arrayToObject: function (arr) {
    var rv = {};
    for (var i = 0; i < arr.length; ++i)
      if (arr[i] !== undefined) rv[i] = arr[i];
    return rv;
  }
};


$.xhrPool = [];
$.xhrPool.abortAll = function () {
  $(this).each(function (i, jqXHR) {
    jqXHR.abort();//停止请求
    $.xhrPool.splice(i, 1);//清除
  });
};
