let asin = null;
var signToken;
let count = 0;
let Rezensenten = [
  "Verifizierter Kauf",
  "Verified Purchase",
  "Acquisto verificato",
  "Achat vérifié",
  "Compra verificada",
];
const Month = (count) => {
  let time = +new Date();
  return time - 24 * 60 * 60 * 1000 * count;
};

let UnicornProduct = function (data = null) {
  //search.js中抓取数据函数调用
  //This is needed regardless of input format
  this.xhrPool = [];

  if (typeof data === "object") {
    var obj = Object.assign(this, data); //合并this和data对象
    obj.amazon = amazon(data.url);
    return obj;
  }

  this.amazon = amazon(data); //amazon方法赋值给this.amazon
  this.url = data; //变量data赋值给this.url

  //if (this.url.indexOf('redirect.html') != -1) this.sponsored = 1;//如果当前网址匹配到了redirect.html，则this.sponsored赋值为1
  //else this.sponsored = 0;//否则this.sponsored赋值为0

  this.domain = this.amazon.hostname; //设置变量damain并赋值为this.amazon.hostname
  this.timestamp = Date.now(); //获取现在的时间
  this.asin = helper.regex(this.amazon.regex.product.url.asin, this.url); //设置变量asin并匹配值
  this.parentAsin = ""; //设置parentAsin变量
  this.asins = [this.asin]; //设置asins变量
  this.keywords = helper.regex(
    this.amazon.regex.product.url.keywords,
    this.url
  ); //设置关键词变量
  this.canonical = helper.regex(
    this.amazon.regex.product.url.canonical,
    this.url
  ); //设置canonical变量
  this.canonicalShort = ""; //设置canonicalShort变量
  this.sales = ""; //设置筛选销量变量
  this.revenue = ""; //设置收入变量
  this.salesRank = ""; //设置销售排行变量
  this.moReviews = "";// 评论率
  this.fba = ""; //设置fba变量
  this.category = ""; //设置分类变量
  this.price = ""; //设置价格变量
  this.brand = ""; //设置品牌变量
  this.image = ""; //设置图片变量
  this.rating = ""; //设置评分变量
  this.seller = ""; //设置卖家
  this.reviews = ""; //设置查看次数变量
  this.sellersUsed = ""; //设置sellersUsed变量
  this.sellersNew = ""; //设置销量变量
  (this.date = ""), (this.dimensions = {}); //设置dimensions变量
  this.variations = {}; //设置变体变量
  this.itMonth = [
    "gennaio",
    "febbraio",
    "marzo",
    "aprile",
    "maggio",
    "giugno",
    "luglio",
    "agosto",
    "settembre",
    "ottobre",
    "novembre",
    "dicembre",
  ];
  this.frMonth = [
    "janvier",
    "février",
    "mars",
    "avril",
    "mai",
    "juin",
    "juillet",
    "août",
    "septembre",
    "octobre",
    "novembre",
    "décembre",
  ];
  // this.spaMonth = ['de enero de', 'de febrero de', 'de marzo de', 'de abril de', 'de mayo de', 'de junio de',
  // 	'de julio de', 'de agosto de', 'de septiembre de', 'de octubre de', 'de noviembre de', 'de diciembre de'
  // ];
  this.spaMonth = [
    "enero",
    "febrero",
    "marzo",
    "abril",
    "mayo",
    "junio",
    "julio",
    "agosto",
    "septiembre",
    "octubre",
    "noviembre",
    "diciembre",
  ];
  this.enMonth = [
    "January",
    "February",
    "March",
    "April",
    "May",
    "June",
    "July",
    "August",
    "September",
    "October",
    "November",
    "December",
  ];
  this.ajaxCompleteCallback = ""; //设置ajax完成变量
  // this.getVariationDetails();
  // if (this.url != "") this.getProductDetails();
  data = null;
};

UnicornProduct.prototype.xhrAbortAll = function () {
  var self = this; //把this赋值给self，以便后面可以直接调用self来获得this值

  this.xhrPool.each(function (i, jqXHR) {
    //循环xhrPool数组
    jqXHR.abort(); //jqXHR终止
    self.xhrPool.splice(i, 1); //从i位置删除一个字符
  });
};

UnicornProduct.prototype.get = function () {
  return {
    //返回设置的变量数据
    url: this.url,
    sponsored: this.sponsored,
    timestamp: this.timestamp,
    domain: this.domain,
    asin: this.asin,
    parentAsin: this.parentAsin,
    asins: this.asins,
    keywords: this.keywords,
    canonical: this.canonical,
    canonicalShort: this.canonicalShort,
    sales: this.sales,
    revenue: this.revenue,
    salesRank: this.salesRank,
    fba: this.fba,
    category: this.category,
    price: this.price,
    dimensions: this.dimensions,
    variations: this.variations,
    date: this.date,
    rank: this.rank,
    title: this.title,
    brand: this.brand,
    image: this.image,
    rating: this.rating,
    reviews: this.reviews,
    sellersUsed: this.sellersUsed,
    sellersNew: this.sellersNew,
    seller: this.seller,
  };
};

UnicornProduct.prototype.getProductDetails = function (nextPage) {
  //获取sales和revenue数据
  if (!this.url) return;
  // console.log("123123",this.url.replace(/&amp;/gi, "&"));
  var self = this;
  let URL = this.url.replace(/&amp;/gi, "&") ? this.url.replace(/&amp;/gi, "&") : this.url
  chrome.runtime.sendMessage(
    {
      //发送消息给background脚本
      type: "USK_LOAD_PRODUCT",
      //   url: this.amazon.product(this.url).url,
      url: URL
    },
    function (result) {
      // console.log("0000000")
      if (!result) return false;
      self.canonical = helper.regex(
        self.amazon.regex.product.html.canonical,
        result.response.body
      ); //获取拼接asin地址
      const asin = self.canonical && self.canonical.split("/dp/")[1];
      self.variantAsin = asin;
      setTimeout(() => {
        self.getMoComments(self);
      }, 0);

      // console.log(result.response.body)
      let selfPrice = self.price;
      var product = self.extractProductDetails(result.response.body); //返回文本
      if (!product.price) product.price = selfPrice;
      self = Object.assign(self, product); //合并self和product对象
      // if (
      //   document.URL.indexOf("gp/bestsellers") != -1 ||
      //   document.URL.match(/Best-Sellers/i)
      // ) {
      // setTimeout(() => {

      // if (!nextPage) {
      //   let exhibition = self.useListInsertionNode(result.response.body, self);
      //   self.exhibition = exhibition;
      // }
      // });
      // }
      if (self.amazon.salesSupported) {
        //判断是否为支持的站点
        var getTokenSetInterval = setInterval(function () {
          //拼接获取sales和revenue数据的ajax请求网址
          //var uri = "domain=" + self.domain + "&category=" + encodeURIComponent(self.category.replace('&amp;', '&')) +
          //"&rank=" + encodeURIComponent(helper.toNumber(self.salesRank)) + "&token=" + signToken ;
          if (signToken != null) {
            clearInterval(getTokenSetInterval);
            let URL = self.amazon.URL[self.amazon.env] + "unicorn/data";
            // self.amazon.URL[self.amazon.env] + "unicorn/data",
            // url: "https://www.amztracker.com/advanced/sales/old",
            let Data = {
              domain: self.domain,
              category: encodeURIComponent(
                self.category.replace("&amp;", "&")
              ),
              rank: encodeURIComponent(helper.toNumber(self.salesRank)),
              token: signToken,
              version: "latest",
            }
            $.ajax({
              url: URL,
              method: "POST",
              cache: false,
              data: Data,
              beforeSend: function (jqXHR) {
                self.xhrPool.push(jqXHR);
              },
              complete: function (jqXHR) {
                var index = self.xhrPool.indexOf(jqXHR);
                if (index > -1) {
                  self.xhrPool.splice(index, 1);
                }
                if (self.ajaxCompleteCallback != "")
                  self.ajaxCompleteCallback(
                    "_history " + self.domain + " " + self.keywords
                  );
              },
              error: function (jqXHR, textStatus, errorThrown) {
                //by ouyang
                var index = self.xhrPool.indexOf(jqXHR);
                if (index > -1) {
                  self.xhrPool.splice(index, 1);
                }

                let exhibition = self.useListInsertionNode(result.response.body, self);
                self.exhibition = exhibition;
              },
              success: function (data) {
                // console.log(data, "------");//self  
                // data:{
                //   "monthly_sales": 1386,
                //   "daily_sales": 52
                // }
                if (data !== "") {
                  const { monthly_sales, daily_sales } = JSON.parse(data);
                  if ($.isNumeric(monthly_sales)) {
                    self.sales = String(monthly_sales); //销量为返回的data值
                    self.revenue = Math.round(
                      helper.delCommafy(self.price) * monthly_sales
                    ); //收入为价格*销量
                  } else {
                    self.sales = "-";
                    self.revenue = "-";
                  }
                  if ($.isNumeric(daily_sales)) {
                    self.daily_sales = daily_sales; //销量为返回的data值
                    self.moReviews = daily_sales;
                  } else {
                    self.daily_sales = "-";
                    self.moReviews = "-";
                  }
                  if (self.daily_sales !== "-" || self.sales !== "-") {
                    let exhibition = self.useListInsertionNode(result.response.body, self);
                    self.exhibition = exhibition;
                  }
                } else {
                  self.sales = "-";
                  self.daily_sales = "-";
                  self.revenue = "-";
                  let exhibition = self.useListInsertionNode(result.response.body, self);
                  self.exhibition = exhibition;
                }
              },
            });
          } else {
            signToken = localStorage.getExpire("signToken");
          }
        }, 5000);
      }
    }
  );
};

UnicornProduct.prototype.getVariationDetails = function (
  index,
  datas,
  ele,
  refreshAll
) {
  //获取变体细节
  var self = this;
  //$.each(data, function(index, variation) {//循环变体数据
  $.each(datas, function (id, value) {
    var str = "";
    if (refreshAll || value.timestamp == "") {
      var url = "https://" + self.domain + "/dp/" + id; //拼接变体请求地址

      $.ajax({
        //获取产品详情页的html代码
        url: url,
        method: "GET",
        cache: false,
        beforeSend: function (jqXHR) {
          self.xhrPool.push(jqXHR);
        },
        complete: function (jqXHR) {
          var index = self.xhrPool.indexOf(jqXHR);
          if (index > -1) {
            self.xhrPool.splice(index, 1);
          }

          if (self.ajaxCompleteCallback != "")
            self.ajaxCompleteCallback(
              "_history " + self.domain + " " + self.keywords
            );
        },
        error: function (jqXHR, textStatus, errorThrown) {
          //by ouyang
          var index = self.xhrPool.indexOf(jqXHR);
          if (index > -1) {
            self.xhrPool.splice(index, 1);
          }
        },
        success: function (html) {
          // console.log(html)
          //赋值
          var product = self.extractProductDetails(html);
          if (product.price == "") product.price = 0;
          value.currency = self.amazon.currency;
          value.category = product.category;
          value.price = product.price;
          value.salesRank = product.salesRank;
          value.image = product.image;
          value.fba = product.fba;
          value.timestamp = Date.now();
          if (self.amazon.salesSupported) {
            //判断是否为支持的站点
            //拼接获取sales和revenue数据的ajax请求网址
            var uri =
              "domain=" +
              self.domain +
              "&category=" +
              encodeURIComponent(product.category.replace("&amp;", "&")) +
              "&rank=" +
              encodeURIComponent(helper.toNumber(product.salesRank)) +
              "&token=" +
              signToken;
            $.ajax({
              url: self.amazon.URL[self.amazon.env] + "unicorn/data?" + uri,
              method: "GET",
              cache: false,
              complete: function (jqXHR) {
                var index = self.xhrPool.indexOf(jqXHR);
                if (index > -1) {
                  self.xhrPool.splice(index, 1);
                }

                //				          if (self.ajaxCompleteCallback != "") self.ajaxCompleteCallback("_history " + self.domain + " " + self.keywords);
              },
              success: function (data) {
                if ($.isNumeric(data)) {
                  //如果有数据
                  product.sales = data; //销量为返回的data值
                  product.revenue = Math.round(
                    helper.delCommafy(product.price) * data
                  ); //收入为价格*销量
                } else {
                  product.sales = 0;
                  product.revenue = 0;
                }
                value.revenue = product.revenue;
                value.sales = product.sales;
                str += "<tr class = 'index-" + index + "'>";
                str += '<td class="td-checkbox"></td>';
                str += '<td class="td-rank"></td>';
                if (value[0].indexOf('"') > -1) {
                  value[0].replace('"', "");
                }
                if (value[1])
                  str +=
                    '<td class="td-title"><div class="ellipsis"><a class="has-tooltipPro has-tooltip" data-tooltipPro=" ' +
                    value[0] +
                    '"&nbsp;"' +
                    value[1] +
                    '" target="_blank" href="' +
                    value.damain +
                    '" data-tooltip=" ' +
                    value[0] +
                    '"&nbsp;"' +
                    value[1] +
                    '" target="_blank" href="' +
                    value.damain +
                    '"> ' +
                    value[0] +
                    "&nbsp;" +
                    value[1] +
                    "</a></div></td>";
                else
                  str +=
                    '<td class="td-title"><div class="ellipsis"><a class="has-tooltipPro has-tooltip" data-tooltipPro=" ' +
                    value[0] +
                    '" target="_blank" href="' +
                    value.damain +
                    '" data-tooltip=" ' +
                    value[0] +
                    '" target="_blank" href="' +
                    value.damain +
                    '"> ' +
                    value[0] +
                    "</a></div></td>";
                str += '<td class="td-brand"><div class="ellipsis"></div></td>';
                str +=
                  '<td class="td-sellers" style="display:none;"></td><td class="td-variations" style="display:none;"></td>';
                if (value.price)
                  str +=
                    '<td class="td-price"><span>' +
                    value.currency +
                    value.price +
                    "</span></td>";
                else str += '<td class="td-price">-</td>';
                if (product.category)
                  str +=
                    '<td class="td-category has-tooltipPro has-tooltip" data-tooltipPro="' +
                    product.category +
                    '" data-tooltip="' +
                    product.category +
                    '"><div class = "ellipsis" >' +
                    value.category +
                    "</div></td>";
                else
                  str +=
                    '<td class="td-category"><div class = "has-tooltipPro has-tooltip" data-tooltipPro="No parent category in this listing." data-tooltip="No parent category in this listing.">-</div>';
                if (value.salesRank)
                  str +=
                    '<td class="td-salesrank">' + value.salesRank + "</td>";
                else
                  str +=
                    '<td class="td-salesrank has-tooltipPro has-tooltip" data-tooltipPro="Amazon doesn’t rank this product in the parent category." data-tooltip="Amazon doesn’t rank this product in the parent category.">-</td>';
                if (value.sales)
                  str += '<td class="td-sales">' + value.sales + "</td>";
                else
                  str +=
                    '<td class="td-sales has-tooltipPro has-tooltip" data-tooltipPro="Monthly sales can’t be estimated without its rank in the parent category."  data-tooltip="Monthly sales can’t be estimated without its rank in the parent category.">-</td>';
                if (value.revenue)
                  str +=
                    '<td class="td-revenue">' +
                    value.currency +
                    value.revenue +
                    "</td>";
                else
                  str +=
                    '<td class="td-revenue has-tooltipPro has-tooltip" data-tooltipPro="Monthly revenue can’t be estimated without its rank in the parent category." data-tooltip="Monthly revenue can’t be estimated without its rank in the parent category.">-</td>';
                str += '<td class="td-reviews"></td>';

                str += '<td class="td-rating"></td>';

                str += '<td class="td-fba has-tooltipPro"><div></div></td>';
                str += '<td class="td-list"></td>';
                ele.after(str);
                $(".analyse").remove();
                $(".bg-white").height(
                  $("#uniPopupPro #results tbody").height() + 20
                );
              },
            });
          }
        },
      });
    }
  });
  //		return data;
  //});
};

UnicornProduct.prototype.getTime = function (siteArr, html, date) {
  var arr = this.enMonth;
  $.each(siteArr, function (index, value) {
    if (date.indexOf(value) > -1) {
      var enTime = arr[index];
      date = date.replace(value, enTime);
    }
  });
  return date;
};

UnicornProduct.prototype.useListInsertionNode = function (html, info) {
  // if (this.canonical.indexOf("/dp/") === -1) return {};
  // const html = info.html;
  info.is_adult = "";
  info.weight = "";
  const asin = this.canonical.split("/dp/")[1];
  const DIV = document.createElement("div");
  let str = "";
  const couponReg = /(?<=\()\S+(?=\))/;
  const regex = this.amazon.regex; //获取站点的正则匹配方式
  const product = {
    seller: "<div> - </div>",
    ASIN: "<div>ASIN： - </div>",
    Coupon: "<div>Coupon： - </div>",
    "Mo. Sales": "<div class='mo_Sales'>Mo. Sales： - </div>",
    "D. Sales": "<div class='d_Sales'>D. Sales： - </div>",
    AmazonChoice: "<div>Amazon's Choice：- </div>",
    SeeTop: "",
    Brand: "<div>Brand： - </div>",
    Revenue: "<div class='mo_Revenue'>Mo. Revenue :  - </div>",
    date: "<div>Date First Available ： - </div>",
  };
  // if (!list) return product;
  const productKey = [
    "seller",
    "ASIN",
    "Coupon",
    "Mo. Sales",
    "D. Sales",
    "AmazonChoice",
    "SeeTop",
    "Brand",
    "Revenue",
    "date",
  ];
  let coupon = helper.regex(regex.product.product_Details.coupon, html);
  // console.log(coupon)
  // if (coupon) {
  //   coupon = coupon.replace(/\s+/g, "").match(couponReg)[0]
  // }
  if (regex.product.product_Details.coupon3 && !coupon) {
    let couponValue = helper.regex(regex.product.product_Details.coupon3, html).replace('-', '')
    coupon = couponValue ? couponValue : ''
  }
  // const ranking = html.match(regex.product.product_Details.ranking);
  const brandDetail = html.match(regex.product.product_Details.brandDetail);
  const soldBy = html.match(regex.product.product_Details.soldBy);
  const soldByUrl =
    soldBy && soldBy[1].match(regex.product.product_Details.nation);
  let nation = soldBy && soldBy[1].indexOf("Amazon") !== -1 ? "US | " : "";
  let seller = helper.regex(regex.product.product_Details.seller, html);
  if (seller == "") {
    seller = helper.regexs(regex.product.product_Details.seller1, html);
  }
  if (regex.product.product_Details.seller2 && seller == "") {
    seller = helper.regexs(regex.product.product_Details.seller2, html);
  }
  // html.split("a-box mbc-offer-row pa_mbc_on_amazon_offer").length - 1;
  // 获取排名有些是 table 格式有的是 UL
  const BSR_TABLE = html.match(regex.product.product_Details.BSR_TABLE);

  const BSR_TABLE2 = html.match(regex.product.product_Details.BSR_TABLE2);

  const BSR_UL = html.match(regex.product.product_Details.BSR_UL);
  DIV.className = "exhibition";
  DIV.id = "exhibition";
  product.Brand = `<div>Brand：${nation}${brandDetail
    ? brandDetail[1].replace(
      /(Visit the |Brand: |Store|Marke:|Marque :|Visiter la boutique|Visita la de|Visita la Store de|Marca:|Visita lo  di )/gi,
      ""
    )
    : "-"
    }</div>`;
  if (brandDetail) {
    info.brandUrl = html.match(regex.product.product_Details.brandDetailUrl)[1];
  }
  // if (soldByUrl) {
  //   $.ajax({
  //     url: soldByUrl[0].replace(/&amp;/g, "&").split("'")[1],
  //     method: "GET",
  //     cache: false,
  //     async: true,
  //     success: function (res) {
  //       if (res) {
  //         const matching = res.match(regex.product.product_Details.brandNation);
  //         if (!matching) return;
  //         const matching1 = matching[1].match(
  //           /<span class="a-list-item">([\s\S]*?)<\/span>/gi
  //         );
  //         console.log(matching1);
  //         nation = matching1 && matching1[matching1.length - 1];
  //         // 品牌 / 国家
  //         product.Brand = `<div>Brand：${nation} | ${
  //           brandDetail &&
  //           brandDetail[1].replace(
  //             /(Visit the |Brand: |Store|Marke:|Marca: |Marca: )/gi,
  //             ""
  //           )
  //         }</div>`;
  //       }
  //     },
  //     error: function (err) {
  //       console.log(err, "===err");
  //     },
  //   });
  // } else {
  //   product.Brand = `<div>Brand：${
  //     brandDetail &&
  //     brandDetail[1].replace(
  //       /(Visit the |Brand: |Store|Marke:|Marque : )/gi,
  //       ""
  //     )
  //   }</div>`;
  // }

  //发货
  product.soldBy = soldBy && `<div>${soldBy[0]}</div>`;

  // 同卖的卖家数量
  product.seller = `<div>sellers：${seller || "-"}</div>`;

  // 优惠
  product.Coupon =
    coupon &&
    `<div class="font_bold">Discount：${coupon}</div>`;
  // 上架时间
  if (html.match(regex.product.product_Details.AmazonChoice)) {
    // 亚马逊推荐
    product[
      "AmazonChoice"
    ] = `<div><span class="font_bold">Amazon's Choice </span>：${html.match(regex.product.product_Details.AmazonChoice)[0]
    }</div>`;
  } else {
    product[
      "AmazonChoice"
    ] = `<div class="font_bold">Amazon's Choice ：- </div>`;
  }
  // 处理特殊情况 获取国家
  if (BSR_TABLE2) {
    const BSR_TR = BSR_TABLE2[0].match(
      regex.product.product_Details.BSR_TABLE_TR
    );
    if (BSR_TR) {
      BSR_TR.forEach((item) => {
        if (item.match(regex.product.html.weight)) {
          // console.log(item.match(regex.product.html.weight));
          const weight = /<td [\s\S]*?>([\s\S]*?)<\/td>/.exec(item)[1].replace("&lrm;", "").split(";");
          // console.log(item.match(regex.product.html.weight));
          info.weight = weight[weight.length - 1]
        }
        if (item.indexOf("Place of Business") !== -1) {
          product.Brand = null;
          const nation = item
            .replace(/[\r\n]/g, "")
            .match(/class="a-size-base prodDetAttrValue">([\s\S]*?)<\/td>/)[1]
            .split(" ");
          product.Brand = `<div>Brand：${nation[nation.length - 1]} | ${brandDetail &&
            brandDetail[1].replace(
              /(Visit the |Brand: |Store|Marke:|Marque : )/gi,
              ""
            )
            }</div>`;
        }
      });
    }
  }
  if (BSR_TABLE) {
    const BSR_TR = BSR_TABLE[0].match(
      regex.product.product_Details.BSR_TABLE_TR
    );
    // console.log(this.parentAsin)

    // 不同站点获取排名的名称不同
    BSR_TR.forEach((item) => {
      // Pounds Kilograms kilogrammes kilogramos Grams Kilogramm Gramm grammes
      // console.log(item)
      if (item.match(regex.product.html.weight)) {
        // console.log(item.match(regex.product.html.weight));
        let wData = /<td [\s\S]*?>([\s\S]*?)<\/td>/.exec(item);
        if (wData) {
          const weight = wData.length >= 2 ? wData[1].replace("&lrm;", "").split(";") : wData[0];
          // console.log(item.match(regex.product.html.weight));
          info.weight = weight[weight.length - 1]
        }
      }
      if (
        item.indexOf("Clasificación en los más vendidos de Amazon") !== -1 ||
        item.indexOf("Posizione nella classifica Bestseller di Amazon") !==
        -1 ||
        item.indexOf("Classement des meilleures ventes d'Amazon") !== -1 ||
        item.indexOf("See Top") !== -1 ||
        item.indexOf("Amazon Bestseller-Rang") !== -1 ||
        item.indexOf("Best Sellers Rank") !== -1
      ) {
        item
          .replace(/[\r\n]/g, "")
          .match(/<span>(.*?)<\/span>/g)
          .forEach((val) => {
            if (val) {
              const strRep = val.replace(
                /(Ver el Top 100 en)|(See Top 100 in)|(Visualizza i Top 100 nella categoria)|(Voir les 100 premiers en)|(Siehe Top 100 in)/,
                ""
              );

              const adult = val.match(regex.product.html.is_adult);
              info.is_adult = adult ? 1 : 0;
              const str1 = /<a href=[\s\S]*?>([\s\S]*?)<\/a>/.exec(strRep);
              // console.log(str1);
              product.SeeTop += `<div>${val
                .replace(/\(([^)]*)\)/, "")
                .replace(str1[1], str1[0])}</div>`;
              // product.SeeTop += `<div>${strRep}</div>`;
            } else {
              product.SeeTop += `<div> - </div>`;
            }
          });
      }
      if (item.indexOf("ASIN") !== -1) {
        const asin = /<td class=[\s\S]*?>(.*?)<\/td>/gi.exec(
          item.replace(/[\r\n]/g, "")
        );
        // if (asin && !this.parentAsin) {
        //   product.ASIN = `<div>ASIN：<span class="font_bold">${asin[1]}</span> <span id="asinCopy" data-asin="${asin[1]}" class="iconfont">&#xe8db;</span></div>`;
        //   this.parentAsin = asin[1];
        // }
      }
    });
  }
  if (BSR_UL) {
    // console.log(BSR_UL);
    let Rank = "<ul>";
    // 分类排名
    const children = BSR_UL[1]
      .replace(/[\r\n]/g, "")
      .match(regex.product.product_Details.BSR_UL_children);
    // 商品ID
    const children2 = BSR_UL[0]
      .replace(/[\r\n]/g, "")
      .match(regex.product.product_Details.BSR_UL_children);
    if (children2) {
      children2.forEach((val) => {
        if (val.match(regex.product.html.weight)) {
          const weight = /<span>([\s\S]*?)<\/span>/.exec(val)[1].replace("&lrm;", "").split(";");
          // console.log(item.match(regex.product.html.weight));
          info.weight = weight[weight.length - 1]
        }
      });
    }
    if (children) {
      children.forEach((item) => {
        const adult = item.match(regex.product.html.is_adult);
        info.is_adult = adult ? 1 : 0;

        // if(item&&item !== "undefined"){
        const strRep = item.replace(
          /(Ver el Top 100 en )|(See Top 100 in )|(Visualizza i Top 100 nella categoria )|(Voir les 100 premiers en )|(Siehe Top 100 in )/,
          ""
        );
        const str1 = /<a href=[\s\S]*?>([\s\S]*?)<\/a>/.exec(strRep);
        if (!str1) return (Rank += item);
        Rank += item
          .replace(`<span class="a-text-bold">Best Sellers Rank:</span>`, "")
          .replace(/\(([^)]*)\)/, "")
          .replace(str1[1], str1[0]);
        // Rank += strRep
        // .replace(`<span class="a-text-bold">Best Sellers Rank:</span>`, "")
        // }
      });
      Rank += "</ul>";
      product["SeeTop"] = Rank;
    }
  }

  // 商品 ID
  product.ASIN = `<div>ASIN：<span class="font_bold">${info.variantAsin || ""
    }</span> <span id="asinCopy" data-asin="${info.variantAsin
    }" class="iconfont">&#xe8db;</span> <span class="iconfont copy_style copy_success-${info.variantAsin
    }">&#xe683;</span></div>`;
  product.Revenue = `<div class='mo_Revenue'>Mo. Revenue：${this.revenue}</div>`;
  product['Mo. Sales'] = `<div class='mo_Sales'>Mo. Sales：  ${info.sales}</div>`;
  product['D. Sales'] = `<div class='mo_Sales'>D. Sales：  ${info.daily_sales}</div>`;
  product.date = `<div>Date First Available：${info.date}</div>`;
  str += "<div class='borderTB'>";
  // if (info.fba) {
  // console.log(info)
  str += `<div class="exhibition_fba"><div class="fba_text">${info.fba}</div></div>`;
  // }
  productKey.forEach((val) => {
    if (product[val]) {
      str += product[val];
    }
  });
  str += "</div>";
  // <div class="Historical_Date" id="Historical_Date" data-asin="${info.variantAsin}">Historical Date</div>
  str += `<div class="foot-btn">
 
  <div class="get_comments" data-asin="${info.variantAsin}" id="onGetComments">Get Reviews</div>
  </div>`;

  DIV.innerHTML = str.replace(/a-list-item/g, "a-list");
  // list.append(DIV);
  return { DIV, str };
};
UnicornProduct.prototype.getMoComments = function (info, callback) {
  if (!info.variantAsin) return;
  const month = Month(30);
  const _this = this;
  const regex = this.amazon.regex; //获取站点的正则匹配方式
  let page = 1;
  let COMMENTS_SUM = 0;
  let allUrl = `/product-reviews/${info.variantAsin}/ref=cm_cr_getr_d_paging_btm_Pages?ie=UTF8&sortBy=recent&pageNumber=Pages&pageSize=20`;
  const sendMessage = () => {
    const url = "https://" + info.domain + allUrl.replace(/(Pages)/g, page);
    let count = 0;
    // fetch(url,{
    //   method: 'GET',
    // })
    // .then(response =>response.text())
    // .then(result =>{
    //       let matchHtml = result.match(/<div id="cm_cr-review_list"[\s\S]*?<div id="reviews-spacing"/gi)
    //       const html = matchHtml.length > 1?matchHtml[0]:"";
    //       const dateList = html.match(regex.comments.date);
    //       if (!dateList) return COMMENTS_SUM;
    //       dateList.forEach((val) => {
    //         let date = null;
    //         let dateRep = helper.regex(
    //           /<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
    //           val
    //         );
    //         // if (dateRep) {
    //         //   dateRep = dateRep.replace(
    //         //     /(Revisado en España el )|(Reviewed in Canada on )|(Recensito in Germania il )|(Rezension aus Deutschland vom )|(Commenté en France le )|(Reviewed in the United Kingdom on )|(Reviewed in the United States on )|(Commenté en Espagne le )|(Recensito in Italia il)|(Revisado en Alemania el )/gi
    //         //   ,"");
    //         // }
    //         // const dateRep = val.replace(/<.*?>/gi, "");
    //         if (_this.amazon.hostname == "www.amazon.de" && dateRep) {
    //           if (dateRep.indexOf("März") > -1) {
    //             dateRep = dateRep.replace("März", "March");
    //           }
    //           if (dateRep.indexOf("Mai") > -1) {
    //             dateRep = dateRep.replace("Mai", "May");
    //           }
    //           if (dateRep.indexOf("Oktober") > -1) {
    //             dateRep = dateRep.replace("Oktober", "October");
    //           }
    //           if (dateRep.indexOf("Dezember") > -1) {
    //             dateRep = dateRep.replace("Dezember", "December");
    //           }
    //         }
    //         if (_this.amazon.hostname == "www.amazon.it" && dateRep)
    //           date = _this.getTime(_this.itMonth, "", dateRep);
    //         if (_this.amazon.hostname == "www.amazon.es" && dateRep)
    //           date = _this.getTime(_this.spaMonth, "", dateRep);
    //         if (_this.amazon.hostname == "www.amazon.fr" && dateRep)
    //           date = _this.getTime(_this.frMonth, "", dateRep);
    //         // if(!date){
    //         //   date = helper.regex(/<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi, val)
    //         // }
    //         if (dateRep && !date) {
    //           date = new Date(helper.trimStr(dateRep)).format("yyyy-MM-dd");
    //         }
    //         // console.log(date, new Date(helper.trimStr(dateRep)).format("yyyy-MM-dd"));
    //         if (new Date(date).getTime() >= month) {
    //           count++;
    //         }
    //       });
    //       COMMENTS_SUM += count;
    //       if (count >= dateList.length) {
    //         page++;
    //         sendMessage();
    //         return;
    //       }
    //       page = 1;
    //       info.moReviews = COMMENTS_SUM;
    //       _this.ajaxCompleteCallback();
    // })
    // .catch(err =>
    //   console.log(err)
    // )
    $.ajax({
      // url: allUrl,
      url,
      method: "GET",
      cache: false,
      success: (result) => {
        let matchHtml = result.match(/<div id="cm_cr-review_list"[\s\S]*?<div id="reviews-spacing"/gi)
        let html = "";
        if (matchHtml) {
          html = matchHtml.length > 0 ? matchHtml[0] : "";
        }
        const dateList = html.match(regex.comments.date);
        if (!dateList) return COMMENTS_SUM;
        dateList.forEach((val) => {
          let date = null;
          let dateRep = helper.regex(
            /<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi,
            val
          );
          // if (dateRep) {
          //   dateRep = dateRep.replace(
          //     /(Revisado en España el )|(Reviewed in Canada on )|(Recensito in Germania il )|(Rezension aus Deutschland vom )|(Commenté en France le )|(Reviewed in the United Kingdom on )|(Reviewed in the United States on )|(Commenté en Espagne le )|(Recensito in Italia il)|(Revisado en Alemania el )/gi
          //   ,"");
          // }
          // const dateRep = val.replace(/<.*?>/gi, "");
          if (_this.amazon.hostname == "www.amazon.de" && dateRep) {
            if (dateRep.indexOf("März") > -1) {
              dateRep = dateRep.replace("März", "March");
            }
            if (dateRep.indexOf("Mai") > -1) {
              dateRep = dateRep.replace("Mai", "May");
            }
            if (dateRep.indexOf("Oktober") > -1) {
              dateRep = dateRep.replace("Oktober", "October");
            }
            if (dateRep.indexOf("Dezember") > -1) {
              dateRep = dateRep.replace("Dezember", "December");
            }
          }
          if (_this.amazon.hostname == "www.amazon.it" && dateRep)
            date = _this.getTime(_this.itMonth, "", dateRep);
          if (_this.amazon.hostname == "www.amazon.es" && dateRep)
            date = _this.getTime(_this.spaMonth, "", dateRep);
          if (_this.amazon.hostname == "www.amazon.fr" && dateRep)
            date = _this.getTime(_this.frMonth, "", dateRep);
          // if(!date){
          //   date = helper.regex(/<span data-hook="review-date"[\s\S]*?>([\s\S]*?)<\/span>/gi, val)
          // }
          if (dateRep && !date) {
            date = new Date(helper.trimStr(dateRep)).format("yyyy-MM-dd");
          }
          // console.log(date, new Date(helper.trimStr(dateRep)).format("yyyy-MM-dd"));
          if (new Date(date).getTime() >= month) {
            count++;
          }
        });
        COMMENTS_SUM += count;
        if (count >= dateList.length) {
          page++;
          sendMessage();
          return;
        }
        page = 1;
        info.moReviews = COMMENTS_SUM;
        _this.ajaxCompleteCallback();
        // console.log()
        // info["Create Date"] = regex.comments.date.exec(html) || "";
        // callback && callback(COMMENTS_SUM);
      },
      error: (err) => {
        console.log(err);
      },
    });
  };
  sendMessage();
};
UnicornProduct.prototype.extractProductDetails = function (html) {
  //获取数据
  var product = {},
    regex = this.amazon.regex; //获取站点的正则匹配方式
  var match = regex.product.html.parentAsin.exec(html); //匹配parentAsin，并赋值给match
  let coupon = helper.regex(regex.product.product_Details.coupon, html);
  if (!coupon && regex.product.product_Details.coupon2) {
    coupon = helper.regex(regex.product.product_Details.coupon2, html);
  }
  if (html.match(regex.product.product_Details.AmazonChoice)) {
    product.amazon_choice = html.match(regex.product.product_Details.AmazonChoice)[0]
  }
  product.seller = helper.regex(regex.product.product_Details.seller, html)
  if (product.seller == "") {
    product.seller = helper.regexs(regex.product.product_Details.seller1, html);
  }
  if (regex.product.product_Details.seller2 && product.seller == "") {
    product.seller = helper.regexs(regex.product.product_Details.seller2, html);
  }
  const couponReg = /(?<=\()\S+(?=\))/;
  const BSR_TABLE2 = html.match(regex.product.product_Details.BSR_TABLE2);
  const BSR_TABLE = html.match(regex.product.product_Details.BSR_TABLE);
  const BSR_UL = html.match(regex.product.product_Details.BSR_UL);

  if (BSR_TABLE2) {
    const BSR_TR = BSR_TABLE2[0].match(
      regex.product.product_Details.BSR_TABLE_TR
    );
    if (BSR_TR && !product.weight) {
      BSR_TR.forEach((item) => {
        if (item.match(regex.product.html.weight)) {
          const weight = /<td [\s\S]*?>([\s\S]*?)<\/td>/.exec(item)[1].replace("&lrm;", "").split(";");
          // console.log(item.match(regex.product.html.weight));
          product.weight = weight[weight.length - 1]

        }
      });
    }
  }
  if (BSR_TABLE) {
    product.SeeTop = "";

    const BSR_TR = BSR_TABLE[0].match(
      regex.product.product_Details.BSR_TABLE_TR
    );
    // console.log(this.parentAsin)

    // 不同站点获取排名的名称不同
    BSR_TR.forEach((item) => {
      if (item.match(regex.product.html.weight) && !product.weight) {

        const weight = /<td [\s\S]*?>([\s\S]*?)<\/td>/.exec(item)[1].replace("&lrm;", "").split(";");
        // console.log(item.match(regex.product.html.weight));
        product.weight = weight[weight.length - 1];
      }
      if (
        item.indexOf("Clasificación en los más vendidos de Amazon") !== -1 ||
        item.indexOf("Posizione nella classifica Bestseller di Amazon") !==
        -1 ||
        item.indexOf("Classement des meilleures ventes d'Amazon") !== -1 ||
        item.indexOf("See Top") !== -1 ||
        item.indexOf("Amazon Bestseller-Rang") !== -1 ||
        item.indexOf("Best Sellers Rank") !== -1
      ) {
        item
          .replace(/[\r\n]/g, "")
          .match(/<span>(.*?)<\/span>/g)
          .forEach((val) => {
            if (val) {
              const strRep = val.replace(
                /(Ver el Top 100 en)|(See Top 100 in)|(Visualizza i Top 100 nella categoria)|(Voir les 100 premiers en)|(Siehe Top 100 in)/,
                ""
              );

              const adult = val.match(regex.product.html.is_adult);
              product.is_adult = adult ? 1 : 0;
              const str1 = /<a href=[\s\S]*?>([\s\S]*?)<\/a>/.exec(strRep);
              // console.log(str1);
              product.SeeTop += `<div>${val
                .replace(/\(([^)]*)\)/, "")
                .replace(str1[1], str1[0])}</div>`;
              // product.SeeTop += `<div>${strRep}</div>`;
            }

          });
      }
    });
  }
  if (BSR_UL) {
    let Rank = "<ul>";

    const children = BSR_UL[1]
      .replace(/[\r\n]/g, "")
      .match(regex.product.product_Details.BSR_UL_children);
    // 商品ID
    const children2 = BSR_UL[0]
      .replace(/[\r\n]/g, "")
      .match(regex.product.product_Details.BSR_UL_children);
    if (children2) {
      children2.forEach((val) => {
        if (val.match(regex.product.html.weight)) {
          const weight = /<span>([\s\S]*?)<\/span>/.exec(val)[1].replace("&lrm;", "").split(";");
          // console.log(item.match(regex.product.html.weight));
          product.weight = weight[weight.length - 1]
          // console.log(product.weight)
        }
      });
    }
    if (children) {
      children.forEach((item) => {
        const adult = item.match(regex.product.html.is_adult);
        product.is_adult = adult ? 1 : 0;
        const strRep = item.replace(
          /(Ver el Top 100 en )|(See Top 100 in )|(Visualizza i Top 100 nella categoria )|(Voir les 100 premiers en )|(Siehe Top 100 in )/,
          ""
        );
        const str1 = /<a href=[\s\S]*?>([\s\S]*?)<\/a>/.exec(strRep);
        if (!str1) return (Rank += item);
        Rank += item
          .replace(`<span class="a-text-bold">Best Sellers Rank:</span>`, "")
          .replace(/\(([^)]*)\)/, "")
          .replace(str1[1], str1[0]);
        // Rank += strRep
        // .replace(`<span class="a-text-bold">Best Sellers Rank:</span>`, "")
        // }
        Rank += "</ul>";
        product["SeeTop"] = Rank;
      })
    }
  }







  product.asins = []; //获得变体总数
  //product.title = helper.regex(regex.search.html.title, html);
  product.parentAsin = helper.regex(regex.product.html.parentAsin, html); //获取匹配parentAsin匹配值

  let featuresMatch = html.match(regex.product.html.features);
  let features = "";
  if (featuresMatch && featuresMatch[0].match(regex.product.html.features2)) {
    featuresMatch[0].match(regex.product.html.features2).forEach((val) => {
      // console.log(val, this.variantAsin);
      features += val.replace(/<.*?>/gi, "") + "\n";
      // console.log(val.replace(/<.*?>/gi, ""))
    });
  }
  product.features = features;
  // product.canonical = helper.regex(regex.product.html.canonical, html); //获取拼接asin地址
  product.canonicalShort = helper.decodeURI(
    helper.regex(regex.product.html.canonicalShort, product.canonical)
  );
  product.image = helper.regex(regex.product.html.imageLarge, html); //产品图片地址
  product.Coupon = coupon
    ? coupon.replace(/\s+/g, "").match(couponReg)[0]
    : "-";
  // product.Coupon = coupon ? coupon : "-";
  if (regex.product.product_Details.coupon3 && (product.Coupon == "" || product.Coupon == '-')) {
    let couponValue = helper.regex(regex.product.product_Details.coupon3, html).replace('-', '')
    product.Coupon = couponValue ? couponValue : '-'
  }
  product.price = helper.regex(regex.product.html.price, html);

  if (
    (this.amazon.hostname == "www.amazon.com" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.de" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.co.uk" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.fr" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.es" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.it" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.ca" && product.price == "")
  ) {
    product.price = helper.regex(regex.product.html.price1, html);
    if (
      regex.product.html.price3 &&
      !helper.regex(regex.product.html.price1, html) &&
      !product.price
    ) {
      product.price = helper.regex(regex.product.html.price3, html);
    }
    // console.log(helper.regex(regex.product.html.price4, html))
    if (
      regex.product.html.price4 &&
      !helper.regex(regex.product.html.price3, html) &&
      !product.price
    ) {
      product.price = helper.regex(regex.product.html.price4, html);
    }
    if (
      regex.product.html.price5 &&
      !helper.regex(regex.product.html.price4, html) &&
      !product.price
    ) {
      product.price = helper.regex(regex.product.html.price5, html);
    }
  }
  if (
    (this.amazon.hostname == "www.amazon.fr" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.co.uk" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.de" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.it" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.es" && product.price == "")
  ) {
    product.price = helper.regex(regex.product.html.price2, html);
  }
  if (
    (this.amazon.hostname == "www.amazon.es" && product.price == "") ||
    // (this.amazon.hostname == "www.amazon.de" && product.price == "") ||
    (this.amazon.hostname == "www.amazon.fr" && product.price == "")
  ) {
    product.price = helper.regex(regex.product.html.price3, html);
  }
  if (
    (this.amazon.hostname == "www.amazon.de" && product.price == "") ||
    this.amazon.hostname == "www.amazon.ca" && product.price === "") {
    product.price = helper.regex(regex.product.html.price6, html);

  }
  // product.price
  if (product.price.indexOf("€") != -1) {
    product.price = product.price.substring(0, product.price.indexOf("€"));
  }
  if (product.price.indexOf("$") != -1) {
    product.price = product.price.split("$")[1];
  }

  //站点需要对价钱进行处理
  if (this.amazon.hostname == "www.amazon.ca") {
    product.price = product.price.replace(/\s/g, "");
    product.price = product.price.replace("$", "");
  }
  // console.log(product.price);
  if (
    this.amazon.hostname == "www.amazon.fr" ||
    // this.amazon.hostname == "www.amazon.de" ||
    this.amazon.hostname == "www.amazon.it"
  ) {
    product.price = product.price.replace(".", "");
    product.price = product.price.replace(/\s/g, "");
    product.price = helper.replaceDot(product.price);
    product.price = helper.formatCurrency(product.price);
  }
  if (this.amazon.hostname == "www.amazon.es") {
    product.price = product.price.replace(".", "");
    product.price = product.price.replace(/\s/g, "");
    product.price = helper.replacePoint(product.price);
  }
  if (this.amazon.hostname == "www.amazon.es") {
    product.price = helper.replaceDot(product.price);
  }
  product.price = product.price.replace(/[\r\n]/g, "");
  // console.log("商品页面抓取的数据product.price", product, html)
  // Sales Rank
  product.salesRank = helper.regex(regex.product.html.salesRank, html); //产品排名
  if (
    (this.amazon.hostname == "www.amazon.co.uk" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.com" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.es" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.ca" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.it" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.de" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.co.jp" && product.salesRank == "")
  ) {
    product.salesRank = helper.regex(regex.product.html.salesRank1, html);
  }

  if (
    (this.amazon.hostname == "www.amazon.com" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.co.uk" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.ca" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.de" && product.salesRank == "") ||
    (this.amazon.hostname == "www.amazon.co.jp" && product.salesRank == "")
  ) {
    product.salesRank = helper.regex(regex.product.html.salesRank2, html);
  }
  if (this.amazon.hostname == "www.amazon.co.uk" && product.salesRank == "" ||
    this.amazon.hostname == "www.amazon.ca" && product.salesRank == "") {
    product.salesRank = helper.regex(regex.product.html.salesRank3, html);
  }
  if (
    this.amazon.hostname == "www.amazon.de" ||
    this.amazon.hostname == "www.amazon.fr" ||
    this.amazon.hostname == "www.amazon.es" ||
    this.amazon.hostname == "www.amazon.it" ||
    this.amazon.hostname == "www.amazon.ca"
  ) {
    product.salesRank = helper.replacePoint(product.salesRank);
  }

  //if (!helper.isNum(product.salesRank)) product.salesRank = helper.regex(regex.product.html.salesRank2, html);//如果销量排名不是数字，则匹配站点product.html.salesRank2方法
  //if (!helper.isNum(product.salesRank) && this.amazon.hostname=='www.amazon.fr') product.salesRank = helper.regex(regex.product.html.salesRank3, html);//如果销量排名不是数字且为法国站点，则匹配站点product.html.salesRank3方法
  /* if (product.salesRank == '') { //如果产品销量排名为空
    //     var rank = html.indexOf('id="SalesRank"');
    //      if(rank==-1){
    //          rank = html.indexOf('Best Sellers Rank');
    //        }
    //        if(rank!=-1){
    //            rank = html.indexOf("#",rank+1);
    //            rank1 = html.indexOf("in",rank);
    //            product.salesRank = html.substring(rank+1, rank1);
    //          }
  } */
  //if (!helper.isNum(product.salesRank)) product.salesRank = ''; //如果product.salesRank的值不为数字，则值为空
  // if (
  //   (this.amazon.hostname == "www.amazon.de" && product.date == "")
  // ) {
  //   product.rating = helper.regex(regex.search.html.rating, html);//获取rating
  // }
  product.brand = helper.regex(regex.search.html.brandDetail, html); //brand
  //if (product.date == '') product.date = helper.regex(this.amazon.regex.product.html.date, html);

  //date
  product.date = helper.regex(regex.product.html.date, html);
  // console.log("商品页面抓取的数据product.date", regex.product.html.date, html)
  if (
    (this.amazon.hostname == "www.amazon.es" && product.date == "") ||
    (this.amazon.hostname == "www.amazon.co.uk" && product.date == "") ||
    (this.amazon.hostname == "www.amazon.ca" && product.date == "") ||
    (this.amazon.hostname == "www.amazon.fr" && product.date == "") ||
    (this.amazon.hostname == "www.amazon.it" && product.date == "")
  ) {
    product.date = helper.regex(regex.product.html.date1, html);
  }

  if (
    (this.amazon.hostname == "www.amazon.de" && product.date == "") ||
    (this.amazon.hostname == "www.amazon.com" && product.date == "") ||
    (this.amazon.hostname == "www.amazon.co.uk" && product.date == "")
  ) {
    product.date = helper.regex(regex.product.html.date2, html);
  }

  if (this.amazon.hostname == "www.amazon.de") {
    if (product.date.indexOf("März") > -1)
      product.date = product.date.replace("März", "March");
    if (product.date.indexOf("Mai") > -1)
      product.date = product.date.replace("Mai", "May");
    if (product.date.indexOf("Oktober") > -1)
      product.date = product.date.replace("Oktober", "October");
    if (product.date.indexOf("Dezember") > -1)
      product.date = product.date.replace("Dezember", "December");
  }
  if (this.amazon.hostname == "www.amazon.it")
    product.date = this.getTime(this.itMonth, html, product.date);
  if (this.amazon.hostname == "www.amazon.es")
    product.date = this.getTime(this.spaMonth, html, product.date);
  if (this.amazon.hostname == "www.amazon.fr")
    product.date = this.getTime(this.frMonth, html, product.date);
  if (product.date)
    product.date = new Date(helper.trimStr(product.date)).format("yyyy/MM/dd");

  //reviews
  product.reviews = helper.regex(regex.product.html.reviews, html);
  if (
    (this.amazon.hostname == "www.amazon.de" && product.reviews == "") ||
    (this.amazon.hostname == "www.amazon.fr" && product.reviews == "") ||
    (this.amazon.hostname == "www.amazon.es" && product.reviews == "") ||
    (this.amazon.hostname == "www.amazon.co.uk" && product.reviews == "") ||
    (this.amazon.hostname == "www.amazon.ca" && product.reviews == "")
  ) {
    product.reviews = helper.regex(regex.product.html.reviews1, html);
  }

  if (this.amazon.hostname == "www.amazon.fr" && product.reviews == "") {
    product.reviews = helper.regex(regex.product.html.reviews2, html);
  }
  product.reviews = helper.replaceBlank(product.reviews);
  if (
    this.amazon.hostname == "www.amazon.de" ||
    this.amazon.hostname == "www.amazon.es" ||
    this.amazon.hostname == "www.amazon.it"
  ) {
    product.reviews = helper.replacePoint(product.reviews);
  }
  // console.log(regex.product.html.reviews)
  // console.log(html)
  /* if (this.amazon.hostname == 'www.amazon.fr' && product.reviews == '') {
    product.reviews = helper.regex(regex.product.html.reviews2, html);
    console.log(2,helper.regex(regex.product.html.reviews2, html))
  } */
  /* if (this.amazon.hostname == 'www.amazon.ca' || this.amazon.hostname == 'www.amazon.com' || this.amazon.hostname == 'www.amazon.co.uk' || this.amazon.hostname == 'www.amazon.de' || this.amazon.hostname == 'www.amazon.es') {
    product.reviews = helper.regex(regex.product.html.reviews, html);
  } */

  /* if (!helper.isNum(product.reviews)) product.reviews = helper.regex(regex.product.html.reviews1, html);
  if (!helper.isNum(product.reviews)) product.reviews = helper.regex(regex.product.html.reviews2, html);
  if (!helper.isNum(product.reviews)) product.reviews = helper.regex(regex.product.html.reviews3, html);
  if (!helper.isNum(product.reviews)) product.reviews = helper.regex(regex.product.html.reviews4, html); */

  // Category
  product.category = helper.regex(regex.product.html.category, html);
  if (product.category == '') {
    product.category = helper.isregex(regex.product.html.category3, html)
  }

  if (product.category.length > 40) product.category = "";

  if (product.category == "Home Improvements")
    product.category = "Home Improvement";

  if (this.amazon.hostname == "www.amazon.co.jp")
    product.category = helper.trimStr(product.category);
  /* if (product.category == "") {
     var num = html.indexOf("class='nav-a nav-b'");
     if(num!=-1){
       num = html.indexOf(">",num);
       num = html.indexOf(">",num+1);
       num1 = html.indexOf("<",num);
       var str = html.substring(num+1, num1)
       product.category = str.replace(/(^\s*)|(\s*$)/g,"");
     }

  }; */

  if (
    (this.amazon.hostname == "www.amazon.co.uk" && product.category == "") ||
    (this.amazon.hostname == "www.amazon.com" && product.category == "") ||
    (this.amazon.hostname == "www.amazon.es" && product.category == "") ||
    (this.amazon.hostname == "www.amazon.fr" && product.category == "") ||
    (this.amazon.hostname == "www.amazon.de" && product.category == "") ||
    (this.amazon.hostname == "www.amazon.ca" && product.category == "")
  ) {
    product.category = helper.regex(regex.product.html.category1, html);
  }

  if (
    (this.amazon.hostname == "www.amazon.com" && product.category == "") ||
    (this.amazon.hostname == "www.amazon.de" && product.category == "") ||
    (this.amazon.hostname == "www.amazon.co.uk" && product.category == "")
  ) {
    product.category = helper.regex(regex.product.html.category2, html);
  }
  if (this.amazon.hostname == "www.amazon.de" && product.category == "") {
    product.category = helper.regex(regex.product.html.category3, html);
  }
  if (product.category.length > 500) {
    product.category = "-"
  }
  // console.log("类别1---------------1222", product.parentAsin, "'---'", product.category)
  // FBA
  var merchantInfo = helper.regex(regex.product.html.merchantInfo, html);
  product.fba = "-";
  if (helper.regex(regex.product.html.fba, html)) {
    product.fba = "FBA";
  }

  if (this.amazon.hostname === "www.amazon.com") {
    if (merchantInfo.match(regex.product.html.amz) && product.fba == "-") {
      product.fba = "AMZ";
    }

    if (merchantInfo.match(regex.product.html.fbm) && product.fba == "-") {
      product.fba = "FBM";
    }
  }
  // AMZ
  if (
    [
      "www.amazon.co.uk",
      "www.amazon.es",
      "www.amazon.fr",
      "www.amazon.it",
      "www.amazon.com",
      "www.amazon.co.jp"
    ].includes(this.amazon.hostname)
  ) {
    if (
      helper.regex(regex.product.html.amz, merchantInfo) &&
      product.fba == "-"
    ) {
      product.fba = "AMZ";
    }
    if (
      helper.regex(regex.product.html.fbm, merchantInfo) &&
      product.fba == "-"
    ) {
      product.fba = "FBM";
    }
    if (regex.product.html.fba2 && product.fba == "-") {
      const fba2 = html.match(regex.product.html.fba2);
      if (fba2 && fba2.length > 1) {
        if (
          fba2[0].indexOf("Amazon") !== -1 &&
          fba2[1].indexOf(">Amazon") !== -1
        ) {
          product.fba = "AMZ";
        }
        if (
          (fba2[0].indexOf("Amazon") !== -1 ||
            fba2[1].indexOf("Amazon") !== -1) &&
          product.fba == "-"
        ) {
          product.fba = "FBA";
        }

        if (
          fba2[0].indexOf("Amazon") === -1 &&
          fba2[1].indexOf("Amazon") === -1
        ) {
          product.fba = "FBM";
        }
      }
    }
  }

  if (helper.regex(regex.product.html.amz, html) && product.fba == "-") {
    product.fba = "AMZ";
  }
  if (this.amazon.hostname == "www.amazon.de" && product.fba == "-") {
    if (helper.regex(regex.product.html.amz1, html) != "") {
      product.fba = "AMZ";
    }
  }
  if (this.amazon.hostname == "www.amazon.de" && product.fba == "-") {
    if (helper.regex(regex.product.html.amz2, html)) {
      product.fba = "AMZ";
    }
  }
  //FBM
  if (
    !helper.regex(regex.product.html.fba, merchantInfo) &&
    !helper.regex(regex.product.html.amz, html) &&
    helper.regex(regex.product.html.fbm, merchantInfo)
  ) {
    product.fba = "FBM";
  }

  // Variations

  // Dimensions
  var dimensions = {};

  var dimensionsJson = helper.regex(regex.product.html.dimensionsJson, html);
  if (dimensionsJson != "") dimensions = JSON.parse(dimensionsJson);

  product.dimensions = dimensions;

  // JSON
  var variations = {};

  var variationsJson = helper.regex(regex.product.html.variationsJson, html);
  if (variationsJson) variations = JSON.parse(variationsJson);

  // Swatches
  var variationsSwatchUnselectedAsin = helper.regexAll(
    regex.product.html.variationsSwatchUnselectedAsin,
    html
  );
  var variationsSwatchUnselectedAttributes = helper.regexAll(
    regex.product.html.variationsSwatchUnselectedAttributes,
    html
  );
  var variationsSwatchSelectedAsin = helper.regexAll(
    regex.product.html.variationsSwatchSelectedAsin,
    html
  );
  var variationsSwatchSelectedAttributes = helper.regexAll(
    regex.product.html.variationsSwatchSelectedAttributes,
    html
  );

  var swatchAsins = variationsSwatchSelectedAsin.concat(
    variationsSwatchUnselectedAsin
  );

  var swatchAttributes = variationsSwatchSelectedAttributes.concat(
    variationsSwatchUnselectedAttributes
  );
  var self = this;

  $.each(swatchAsins, function (index, asin) {
    variations[asin] = [swatchAttributes[index]];
  });

  $.each(variations, function (asin, attributes) {
    product.asins.push(asin);
    variations[asin] = helper.arrayToObject(variations[asin]);
    variations[asin].price = "";
    variations[asin].category = "";
    variations[asin].sales = "";
    variations[asin].revenue = "";
    variations[asin].salesRank = "";
    variations[asin].image = "";
    variations[asin].timestamp = "";
    variations[asin].damain = "https://" + self.domain + "/dp/" + asin;
    variations[asin].fba = "";
  });

  product.asins = product.asins.filter(helper.onlyUnique);
  product.variations = variations;
  return product;
};

UnicornProduct.prototype.getComments = function (params = {}, ev, count = 3) {
  sessionStorage.removeItem("onGetComments");
  sessionStorage.setItem("loading", "true");
  let { page, star, type, id, keywords, sort, Verified } = params;
  const regex = this.amazon.regex; //获取站点的正则匹配方式
  const allUrl = `product-reviews/${id}/ref=cm_cr_getr_d_paging_btm_${page}?ie=UTF8&sortBy=recent&pageNumber=1&pageSize=20`;
  let loopCount = 0;
  let num = 0;
  let percent = 0;
  // https://www.amazon.com/product-reviews/B07BFS3G7P/ref=zg-cm_cr_getr_d_paging_btm_1/131-8953953-1451059?pf_rd_p=b47d5c1d-5fb5-4df9-892f-181321b38571&pf_rd_r=1AEF5D6MF803X36GJ3H1&pd_rd_r=6f277d0f-6fae-47ba-b002-45e6ba496201&pd_rd_i=B07BFS3G7P

  // https://www.amazon.com/dp/product-reviews/B076Q94BRS/ref=cm_cr_getr_d_paging_btm_1?ie=UTF8&sortBy=helpful&filterByStar=all_stars&reviewerType=all_reviews&pageNumber=1&filterByKeyword=&_=1632985041358

  $("#modal_tbody table").show();
  $(".comments_Empty").css("display", "none");
  const CommentsAjax = () => {
    let tbody = "";
    const filtrateUrl = `/product-reviews/${id}/ref=cm_cr_getr_d_paging_btm_${page}?ie=UTF8&sortBy=${sort}&filterByStar=${star}&reviewerType=${Verified}&pageNumber=${page}&filterByKeyword=${keywords}&pageSize=50`;
    let length = null;
    if (count !== "Infinity") {
      length = $("#unicorn_modal tbody")[0].children.length;
    } else {
      length = $("#allDownload tbody")[0].children.length;
    }

    $.ajax({
      url: filtrateUrl,
      method: "GET",
      cache: false,
      async: false,
      success: (res) => {
        const arr = [];
        let review_rating = regex.comments.review_rating.exec(res);
        if (review_rating) {
          num = review_rating[1]
            .replace(/<span>|[\r\n]/g, "")
            .match(/\d+(.\d+)?/g)[1]
            .replace(",", "");
          document.getElementsByClassName("review_rating")[0].innerText =
            review_rating[1].replace(/<span>|[\r\n]/g, "");
        }

        const html = res.match(
          /<div id="cm_cr-review_list"[\s\S]*?<div id="reviews-spacing"/gi
        )[0];
        const str = html.match(regex.comments.userName);
        const helpful = html.match(regex.comments.helpful);

        // console.log(str);
        html.match(regex.comments.userName);
        html.match(regex.comments.review_title);
        html.match(regex.comments.homeLink);
        // html.match(regex.comments.review_title);
        html.match(regex.comments.review);
        html.match(regex.comments.review_Link);
        html.match(regex.comments.stars);
        // html.match(regex.comments.helpful);
        html.match(regex.comments.helpful);
        html.match(regex.comments.variant);
        html.match(regex.comments.verify);
        html.match(regex.comments.date);
        // console.log("↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑");
        if (page !== 1 && !str) {
          $(".loding_more").addClass("uniHide");
          $(".table_more").removeClass("uniHide");
          sessionStorage.removeItem("unicorn_Dowbload");
          sessionStorage.removeItem("loading");
          if (count === "Infinity") {
            this.exportExcelCallback("allDownload");
            return;
          }
          if (ev === "click") {
            $(".table_description").show();
            $(".table_description").text("No further comments");
            sessionStorage.removeItem("loading");
          }
          return;
        }
        if (!str) {
          $(".loding_more").addClass("uniHide");
          $(".table_more").removeClass("uniHide");
          $("#modal_tbody table").hide();
          $(".comments_Empty").css("display", "flex");
          if (ev === "click") {
            $(".table_description").show();
            $(".table_description").text("No comments");
          }
          return;
        }
        for (let a = 0; a < str.length; a++) {
          const info = {};
          let helpful2 = null;
          if (helpful && helpful[a]) {
            helpful2 = helpful[a].match(regex.comments.helpful2);
          }
          length += 1;
          info.UseName = regex.comments.userName.exec(html) || "";
          info.homeLink = regex.comments.homeLink.exec(html) || "";
          info.Title = regex.comments.review_title.exec(html) || "";
          info.Reviews = regex.comments.review.exec(html) || "";
          info.review_Link = regex.comments.review_Link.exec(html) || "";
          info.Star = regex.comments.stars.exec(html) || "";

          info.Helpful = helpful2 ? helpful2[0].replace(/<.*?>/gi, "") : "";

          info.Variant = regex.comments.variant.exec(html) || "";
          info["Verified Purchase"] = regex.comments.verify.exec(html) || "";
          info["Create Date"] = regex.comments.date.exec(html) || "";
          // console.log(info)
          arr.push(info);

          this.commentsToby(info, length, (tr) => {
            tbody += tr;
          });
        }
        page++;
        loopCount++;
        if (num) {
          percent = ((length / num) * 100).toFixed(0);
        }
        if (count !== "Infinity") {
          if (page !== 1) {
            $("#unicorn_modal tbody")[0].innerHTML += tbody;
          } else {
            $("#unicorn_modal tbody")[0].innerHTML = tbody;
          }
          params.page = page;
        } else {
          $(".percent").text(`${percent}%`);
          $(".progress").css(`width`, `${percent > 100 ? 100 : percent}%`);
          $("#allDownload tbody")[0].innerHTML += tbody;
        }

        if (loopCount < count && !sessionStorage.getItem("unicorn_close")) {
          setTimeout(() => {
            CommentsAjax();
          }, 0);
        } else {
          sessionStorage.removeItem("loading");
          loopCount = 0;
          $(".loding_more").addClass("uniHide");
          $(".table_more").removeClass("uniHide");
        }

        // params.arr.psuh(arr);
        // params.arr = arr;
      },
    });
  };
  CommentsAjax();
};
UnicornProduct.prototype.modalState = function (parentName) {
  const add = (nodeName, calssName) => {
    $(`${parentName} `);
  };
  const remove = (nodeName, calssName) => { };
  return { add, remove };
};
UnicornProduct.prototype.ajaxComments = function (url, callback) { };
UnicornProduct.prototype.commentsToby = function (info, length, callback) {
  let tr = "";
  let date = null;
  let Helpful = null;
  tr += `<tr>`;
  tr += `<td ><span style="width: 4vw">${length}</span></td>`;


  tr += `<td><a target="_blank" style="width: 6vw;" href="${info.homeLink[1]
    }">${info.UseName ? info.UseName[1] : "-"}</a></td>`;

  tr += `<td width="240" style="height:200px;text-align: center;"><img data-v-cb59515e="" src="https://lf3-cdn-tos.bytescm.com/obj/static/xitu_juejin_web/img/default.640d9a7.png" width="240" height="200" class="banner-image"></td>`;

  tr += `<td style="text-align: left; white-space: nowrap;"><a title="${info.Title ? info.Title[1].replace(/<.*?>/gi, "") : ""
    }" target="_blank" href="${info.review_Link[1]}">${info.Title ? info.Title[1].replace(/<.*?>/gi, "") : "-"
    }</a></td>`;

  // tr+=`<td><a href="${info.review_Link[1]}">${info.Title?info.Title[1]:"-"}</a></td>`;
  tr += `<td style="text-align: left;"><span title="${info.Reviews ? info.Reviews[1].replace(/<.*?>/gi, "") : ""
    }">${info.Reviews ? info.Reviews[1].replace(/<.*?>/gi, "") : "-"
    }</span></td>`;

  tr += `<td ><span style="width: 5vw">${info.Star ? info.Star[1] : "-"
    }</span></td>`;
  if (info.Helpful) {
    if (info.Helpful.replace(/\D/g, "")) {
      Helpful = info.Helpful.replace(/\D/g, "");
    }

    if (
      /One person|Eine Person|Una persona|Une personne|/gi.exec(
        info.Helpful
      )[0] &&
      !Helpful
    ) {
      Helpful = 1;
    }
    if (!Helpful) {
      Helpful = "-";
    }
  } else {
    Helpful = "-";
  }
  tr += `<td ><span style="width: 5vw">${Helpful}</span></td>`;

  tr += `<td style=""><span style="width: 5vw" title="${info.Variant ? info.Variant[1].replace(/<.*?>/gi, "") : "-"
    }">${info.Variant ? info.Variant[1].replace(/<.*?>/gi, "") : "-"
    }</span></td>`;

  if (info["Verified Purchase"]) {
    tr += `<td><span style="width: 150px;">${Rezensenten.includes(info["Verified Purchase"][1]) ? "Yes" : "No"
      }</span></td>`;
  } else {
    tr += `<td><span style="width: 150px;"> - </span></td>`;
  }
  if (this.amazon.hostname == "www.amazon.de" && info["Create Date"]) {
    if (info["Create Date"][1].indexOf("März") > -1)
      info["Create Date"][1] = info["Create Date"][1].replace("März", "March");
    if (info["Create Date"][1].indexOf("Mai") > -1)
      info["Create Date"][1] = info["Create Date"][1].replace("Mai", "May");
    if (info["Create Date"][1].indexOf("Oktober") > -1)
      info["Create Date"][1] = info["Create Date"][1].replace(
        "Oktober",
        "October"
      );
    if (info["Create Date"][1].indexOf("Dezember") > -1)
      info["Create Date"][1] = info["Create Date"][1].replace(
        "Dezember",
        "December"
      );
  }
  if (this.amazon.hostname == "www.amazon.it" && info["Create Date"])
    date = this.getTime(this.itMonth, "", info["Create Date"][1]);
  if (this.amazon.hostname == "www.amazon.es" && info["Create Date"])
    date = this.getTime(this.spaMonth, "", info["Create Date"][1]);
  if (this.amazon.hostname == "www.amazon.fr" && info["Create Date"][1])
    date = this.getTime(this.frMonth, "", info["Create Date"][1]);

  if (info["Create Date"] && !date)
    date = new Date(helper.trimStr(info["Create Date"][1])).format(
      "yyyy/MM/dd"
    );

  tr += `<td style="height: 32px;"><span style="width:6vw">${date}</span></td>`;
  tr += "</tr>";
  callback(tr);
};
UnicornProduct.prototype.filterComments = function (params) {
  // console.log(params);
  const { arr } = params;
  arr.forEach((val) => { });
};
Date.prototype.format = function (format) {
  var o = {
    "M+": this.getMonth() + 1, //month
    "d+": this.getDate(), //day
    "h+": this.getHours(), //hour
    "m+": this.getMinutes(), //minute
    "s+": this.getSeconds(), //second
    "q+": Math.floor((this.getMonth() + 3) / 3), //quarter
    S: this.getMilliseconds(), //millisecond
  };
  if (/(y+)/.test(format))
    format = format.replace(
      RegExp.$1,
      (this.getFullYear() + "").substr(4 - RegExp.$1.length)
    );
  for (var k in o)
    if (new RegExp("(" + k + ")").test(format)) {
      if (o[k] < 10) o[k] = "0" + o[k];
      else o[k] = o[k];
      format = format.replace(RegExp.$1, o[k]);
    }
  return format;
};
