var search;

$(document).ready(function() {
  var filters = {};
  var sFilters = {};
  if (localStorage.setFilters != undefined){
      filters = JSON.parse(localStorage.setFilters);
      filters.salesRank = filters.salesrank;
      delete filters.salesrank;
      delete filters.hideSponsored;
      sFilters.fba = filters.onlyFba;
      delete filters.onlyFba;
      sFilters.sellersNew = filters.sellers.min;
      sFilters.sellersUsed = filters.sellers.max;
      delete filters.sellers;

      for (var f in filters){
          if (filters[f].max == "" && filters[f].min == "") delete filters[f];
      }
      for (var sf in sFilters){
        if (sFilters[sf] == "") delete sFilters[sf];
      }
  }

  var historyIndex = helper.regex(/\?history=(.*)/i, document.URL).replace(/%20/g, ' ');//获取toimage页面的网址的history的值，并用空值来代替%20
//获取本地缓存数据
  chrome.storage.local.get(null, function(result) {
    search = result[historyIndex];//获取当前网址的关键词
    var productsCount = 0;
    $.each(search.products, function(index, product) {

      var filtred = false;
      if (filters != "" || sFilters != ""){
        index  = productsCount;
          if (sFilters.fba == 1 && product['fba'] == "-") filtred = true;
          if (sFilters.sellersNew != "" && product.sellersNew < sFilters.sellersNew) filtred = true;
          if (sFilters.sellersUsed != "" && product.sellersUsed.replace('-','') < sFilters.sellersUsed) filtred = true;
          if (filters != "") {
              for (var f in filters) {
                  if (filters[f].min != "" && product[f].toString().replace(',','').replace('-','') < filters[f].min) filtred = true;
                  if (filters[f].max != "" && product[f].toString().replace(',','').replace('-','') > filters[f].max) filtred = true;
              }
          }
      }
      if (filtred) return true;
      var td = [];
      productsCount++;
      td.push("<td class='td-rank'>" + product.rank + "</td>");
      td.push("<td class='td-product'><div class='ellipsis'>" + product.title + "</div></td>");
      td.push("<td class='td-category'><div class='ellipsis'>" + product.category + "</div></td>");
      td.push("<td class='td-sellers'>" + product.sellersNew + " / " + product.sellersUsed + "</td>");

      if (product.asins.length < 1) td.push("<td class='td-variations'>1</td>");
      else td.push("<td class='td-variations'>" + product.asins.length + "</td>");

      if (helper.toNumber(product.price) > 0) td.push("<td class='td-price'>$" + helper.toNumber(product.price).toFixed(2) + "</td>");
      else td.push("<td class='td-price'>-</td>");

      td.push("<td class='td-salesrank'>" + product.salesRank + "</td>");

      if (product.sales < 5) td.push("<td class='td-sales'>< 5</td>");
      else td.push("<td class='td-sales'>" + product.sales + "</td>");

      if (helper.toNumber(product.price) == 0) {
        td.push("<td class='td-revenue'>-</td>");
      }
      else {
        if (product.sales < 5) td.push("<td class='td-revenue'>< $" + helper.numberWithCommas(Math.round(5 * helper.toNumber(product.price))) + "</td>");
        else td.push("<td class='td-revenue'>$" + helper.numberWithCommas(Math.round(helper.toNumber(product.sales) * helper.toNumber(product.price))) + "</td>");
      }

      td.push("<td class='td-reviews'>" + product.reviews + "</td>");
      td.push("<td class='td-rating'>" + product.rating + "</td>");
      td.push("<td class='td-fba'>" + product.fba + "</td>");

      var tr = "<tr>" + td.join('') + "</tr>";

      if (index < 20) $('#results-table>tbody').append(tr);

    });

    $('tr').click(function() {
      $(this).toggleClass('highlight');
      canvasToLink();
    });

    $('.btn-close').click(function() {
      window.close();
    });


    canvasToLink();//生成图片事件
  });

});


function canvasToLink() {

  html2canvas($('#container'), {//第三方插件，第一个参数为图片容器，第二个参数为对象方法
    onrendered: function(canvas) {
      var dt = canvas.toDataURL('image/png');//转化为base64位格式地址
        $('#downloadLink').prop('href', dt);//添加href属性
    }
  });

}
